SystemOrganization addCategory: #'Pier-Admin-Setup-Core'!
SystemOrganization addCategory: #'Pier-Admin-Setup-NewKernelFromDistribution'!
SystemOrganization addCategory: #'Pier-Admin-Setup-RecreateExportedKernel'!
SystemOrganization addCategory: #'Pier-Admin-Setup-ExistingKernel'!
SystemOrganization addCategory: #'Pier-Admin-UI'!

PRPierFrame subclass: #PRAdminPierComponent
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminPierComponent commentStamp: 'NickAger 3/7/2012 08:41' prior: 0!
Specialises ==PRPierFrame== to:
- hold the kernel which is passed to me by ==PRAdminLogin== when I am created.
- create a specialised context ==PRAdminContext== 
- provides an empty environment when rendering non-default views, where non-default views are defined by:

+value:source|class=PRAdminPierComponent |selector=isShowingPreview+!

!PRAdminPierComponent class methodsFor: 'instance creation' stamp: 'NickAger 3/3/2012 09:20'!
kernel: kernel
	| pierComponent |
	pierComponent := self new
		kernel: kernel;
		yourself.
		
	pierComponent addContextFilter "need to manually add the context filter as #initialRequest: will not be called as we've only just created the component".
	
	^ pierComponent! !

!PRAdminPierComponent methodsFor: 'accessing' stamp: 'NickAger 2/13/2012 17:38'!
context
	"Answer the admin context, ensuring creation of standard Seaside urls (not RESTful urls) within pier admin"
	^ context ifNil: [ context := PRAdminContext kernel: self kernel ]! !

!PRAdminPierComponent methodsFor: 'accessing' stamp: 'NickAger 2/13/2012 17:23'!
editingEnvironment
	^ self context structure editingEnvironment
! !

!PRAdminPierComponent methodsFor: 'accessing' stamp: 'NickAger 2/13/2012 18:21'!
environment
	self isShowingPreview ifTrue: [ ^ super environment ].
	self isEditing ifTrue: [ ^ self editingEnvironment ].
	
	^ PRStructure emptyEnvironment
! !

!PRAdminPierComponent methodsFor: 'testing' stamp: 'NickAger 2/13/2012 17:27'!
isEditing
	^ self context command isKindOf: PREditCommand! !

!PRAdminPierComponent methodsFor: 'testing' stamp: 'NickAger 11/10/2011 19:41'!
isShowingPreview
	^ self context command asComponent isKindOf: PRDefaultView! !

!PRAdminPierComponent methodsFor: 'accessing' stamp: 'NickAger 2/13/2012 17:38'!
kernel
	^ kernel! !

!PRAdminPierComponent methodsFor: 'accessing' stamp: 'NickAger 2/13/2012 18:13'!
kernel: anObject
	kernel := anObject.
! !

!PRAdminPierComponent methodsFor: 'instance creation' stamp: 'NickAger 3/3/2012 09:23'!
setLoggedInUser: aUser
	self context: (self context user: aUser)! !

!PRAdminPierComponent methodsFor: 'updating' stamp: 'NickAger 9/21/2011 11:20'!
updateRoot: anHtmlRoot
	PRBlueprintLibrary default updateRoot: anHtmlRoot.
	PRJavaScriptSupport default updateRoot: anHtmlRoot. 
	
	super updateRoot: anHtmlRoot.
! !

WAFileLibrary subclass: #PRAdminFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 3/5/2012 16:38'!
pieradminCss
	^ '
html {
  height:100%;
  overflow:hidden;
}

body {
  background: white !!important;
  font-family:Verdana, Helvetica, Geneva, sans-serif;
  font-size:75%;
  height:100%;
  margin:0 0 0 0px;
  overflow:hidden;
  padding:0;
}

a {
	text-decoration: none;
}

tr, th {
	-moz-border-radius: 0em !!important;
	-webkit-border-radius: 0em !!important;
	border-radius: 0em !!important;
}

a.external { 
	background: url(/files/PRAdminFileLibrary/external.png) right center no-repeat; padding-right: 14px; 
}

.ui-layout-pane
{
  font-family:Verdana, Helvetica, Geneva, sans-serif;
  background:#FFF;
  border:1px solid #BBB;
  overflow:auto;
  padding: 1px; 
  text-align: left;
}

.ui-layout-pane-center
{
  padding:4px;
  padding-left:10px;
}

.ui-layout-pane-north
{
  border-bottom:0;
  padding:0;
}

.ui-layout-pane-west
{
  overflow:hidden;
}

.ui-layout-resizer
{
  background:#DDD;
}

.ui-layout-toggler
{
  background:#AAA;
}

.ui-layout-toggler .content
{
  font-size:12px;
  font-weight: bold;
  text-align:center;
}

.ui-layout-toggler-north .content
{
  font-size: 7px;
}

.ui-accordion .ui-accordion-content
{
  padding-bottom:4px!!important;
  padding-top:0;
}

.icon a
{
  background:#FFF;
  outline:none;
}

.search input.text
{
  border:1px solid #FFF;
  color:#000;
}

.mainbody
{
  padding-bottom:15em;
  padding-top:4em;
}



#sidebar
{
  font-family:Verdana, Helvetica, Geneva, sans-serif;
  background:#fff;
  color:#000;
}

#sidebar #header h1{
	color: black;
	background: #eeeeee;
	padding: 2px;
	padding-left: 4px;
	height: 20px;
	margin-top: 4px;
	margin-right: 4px;
	margin-bottom: 5px;
	font-size:18px;
}

#sidebar #header.title {
	margin-left: 5px;
	margin-bottom: 10px;
}

#sidebar #browser .menuitem.page
{
  background-image:url(text-html.png);
}

#sidebar #browser .menuitem.system
{
  background-image:url(applications-system.png);
}

#sidebar #browser .menuitem.management
{
  background-image:url(preferences-system.png);
}

#sidebar #browser .menuitem.components
{
  background-image:url(package-x-generic.png);
}

#sidebar #browser .menuitem.templates
{
  background-image:url(x-office-document-template.png);
}

#sidebar #commands {
  margin-top: 30px;
  margin-left: 5px;
}

#sidebar #refreshNavigator {
	margin-top:5px;
}

#sidebar #pierInstanceLink {
  margin-top: 10px;
  margin-left: 5px;
}

.wiki a:hover {
	border: none;
}

.main
{
	height: 100%;
	width: 100%;
	overflow: hidden;
	
}

.jstree-default.jstree-focused {
	background: none;
}

div#tabs {
	font-family:Verdana, Helvetica, Geneva, sans-serif;
	background-color: #eeeeee;
	margin-bottom: 5px;
}

ul.tabs {
	margin: 0;
	padding: 0;
	list-style-type: none;
	list-style-image: none;
}

.tabs li {
	display: inline-block;
}

.tabs li a {
	padding: 0 1em 1px;
	line-height: 25px;
	font-size: 1.0em;
	color: black;
	text-decoration: none;
	margin-bottom: none;
}

.tabs li.active a,  .tabs  li a:hover {
	border-bottom: 2px solid #aaaaaa;
	background: none;
}

.tabs li.active a {
	border-bottom-color: #cccccc;
}

iframe#iFrameView {
	width:100%;
	height:800px;
	border:none;
	overflow: auto;
}

#main > #content {
	border: 1px;
	border-style: solid;
	border-color: #eeeeee;
	height: 800px;
}

#loggedInAs {
	font-size: 80%
}

#vakata-contextmenu {
	font-family:Verdana, Helvetica, Geneva, sans-serif;
}

#vakata-contextmenu ins {
	background:none ;
}

.adminLogin {
	padding: 10px;
}

.adminLogin h1 {
	font-size: 30px;
}

.adminLoginTitle {
	vertical-align: top;
}
'! !

!PRAdminFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 2/29/2012 18:04'!
pierlogo75x35Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 75 0 0 0 35 8 6 0 0 0 220 233 247 221 0 0 0 4 103 65 77 65 0 0 177 142 124 251 81 147 0 0 10 48 105 67 67 80 73 67 67 32 80 114 111 102 105 108 101 0 0 72 137 157 150 119 84 84 215 22 135 207 189 119 122 161 205 48 20 41 67 239 189 13 32 189 55 169 210 68 97 152 25 96 40 3 14 51 52 177 33 162 2 17 69 68 4 21 65 130 34 6 140 134 34 177 34 138 133 128 96 193 30 144 32 160 196 96 20 81 81 121 51 178 86 116 229 229 189 151 151 223 31 103 125 107 159 189 247 61 103 239 125 214 186 0 144 188 253 185 188 116 88 10 128 52 158 128 31 226 229 74 143 140 138 166 99 251 1 12 240 0 3 204 0 96 178 50 51 2 66 61 195 128 72 62 30 110 244 76 145 19 248 34 8 128 55 119 196 43 0 55 141 188 131 232 116 240 255 73 154 149 193 23 136 210 4 137 216 130 205 201 100 137 184 80 196 169 217 130 12 177 125 70 196 212 248 20 49 195 40 49 243 69 7 20 177 188 152 19 23 217 240 179 207 34 59 139 153 157 198 99 139 88 124 230 12 118 26 91 204 61 34 222 154 37 228 136 24 241 23 113 81 22 151 147 45 226 91 34 214 76 21 166 113 69 252 86 28 155 198 97 102 2 128 34 137 237 2 14 43 73 196 166 34 38 241 195 66 220 68 188 20 0 28 41 241 43 142 255 138 5 156 28 129 248 82 110 233 25 185 124 110 98 146 128 174 203 210 163 155 217 218 50 232 222 156 236 84 142 64 96 20 196 100 165 48 249 108 186 91 122 90 6 147 151 11 192 226 157 63 75 70 92 91 186 168 200 214 102 182 214 214 70 230 198 102 95 21 234 191 110 254 77 137 123 187 72 175 130 63 247 12 162 245 125 177 253 149 95 122 61 0 140 89 81 109 118 124 177 197 239 5 160 99 51 0 242 247 191 216 52 15 2 32 41 234 91 251 192 87 247 161 137 231 37 73 32 200 176 51 49 201 206 206 54 230 114 88 198 226 130 254 161 255 233 240 55 244 213 247 140 197 233 254 40 15 221 157 147 192 20 166 10 232 226 186 177 210 83 211 133 124 122 102 6 147 197 161 27 253 121 136 255 113 224 95 159 195 48 132 147 192 225 115 120 162 136 112 209 148 113 121 137 162 118 243 216 92 1 55 157 71 231 242 254 83 19 255 97 216 159 180 56 215 34 81 26 62 1 106 172 49 144 26 160 2 228 215 62 128 162 16 1 18 115 64 180 3 253 209 55 127 124 56 16 191 188 8 213 137 197 185 255 44 232 223 179 194 101 226 37 147 155 248 57 206 45 36 140 206 18 242 179 22 247 196 207 18 160 1 1 72 2 42 80 0 42 64 3 232 2 35 96 14 108 128 61 112 6 30 192 23 4 130 48 16 5 86 1 22 72 2 105 128 15 178 65 62 216 8 138 64 9 216 1 118 131 106 80 11 26 64 19 104 1 39 64 7 56 13 46 128 203 224 58 184 1 110 131 7 96 4 140 131 231 96 6 188 1 243 16 4 97 33 50 68 129 20 32 85 72 11 50 128 204 33 6 228 8 121 64 254 80 8 20 5 197 65 137 16 15 18 66 249 208 38 168 4 42 135 170 161 58 168 9 250 30 58 5 93 128 174 66 131 208 61 104 20 154 130 126 135 222 195 8 76 130 169 176 50 172 13 155 192 12 216 5 246 131 195 224 149 112 34 188 26 206 131 11 225 237 112 21 92 15 31 131 219 225 11 240 117 248 54 60 2 63 135 103 17 128 16 17 26 162 134 24 33 12 196 13 9 68 162 145 4 132 143 172 67 138 145 74 164 30 105 65 186 144 94 228 38 50 130 76 35 239 80 24 20 5 69 71 25 161 236 81 222 168 229 40 22 106 53 106 29 170 20 85 141 58 130 106 71 245 160 110 162 70 81 51 168 79 104 50 90 9 109 128 182 67 251 160 35 209 137 232 108 116 17 186 18 221 136 110 67 95 66 223 70 143 163 223 96 48 24 26 70 7 99 131 241 198 68 97 146 49 107 48 165 152 253 152 86 204 121 204 32 102 12 51 139 197 98 21 176 6 88 7 108 32 150 137 21 96 139 176 123 177 199 176 231 176 67 216 113 236 91 28 17 167 138 51 199 121 226 162 113 60 92 1 174 18 119 20 119 22 55 132 155 192 205 227 165 240 90 120 59 124 32 158 141 207 197 151 225 27 240 93 248 1 252 56 126 158 32 77 208 33 56 16 194 8 201 132 141 132 42 66 11 225 18 225 33 225 21 145 72 84 39 218 18 131 137 92 226 6 98 21 241 56 241 10 113 148 248 142 36 67 210 39 185 145 98 72 66 210 118 210 97 210 121 210 61 210 43 50 153 172 77 118 38 71 147 5 228 237 228 38 242 69 242 99 242 91 9 138 132 177 132 143 4 91 98 189 68 141 68 187 196 144 196 11 73 188 164 150 164 139 228 42 201 60 201 74 201 147 146 3 146 211 82 120 41 109 41 55 41 166 212 58 169 26 169 83 82 195 82 179 210 20 105 51 233 64 233 52 233 82 233 163 210 87 165 39 101 176 50 218 50 30 50 108 153 66 153 67 50 23 101 198 40 8 69 131 226 70 97 81 54 81 26 40 151 40 227 84 12 85 135 234 67 77 166 150 80 191 163 246 83 103 100 101 100 45 101 195 101 115 100 107 100 207 200 142 208 16 154 54 205 135 150 74 43 163 157 160 221 161 189 151 83 150 115 145 227 200 109 147 107 145 27 146 155 147 95 34 239 44 207 145 47 150 111 149 191 45 255 94 129 174 224 161 144 162 176 83 161 67 225 145 34 74 81 95 49 88 49 91 241 128 226 37 197 233 37 212 37 246 75 88 75 138 151 156 88 114 95 9 86 210 87 10 81 90 163 116 72 169 79 105 86 89 69 217 75 57 67 121 175 242 69 229 105 21 154 138 179 74 178 74 133 202 89 149 41 85 138 170 163 42 87 181 66 245 156 234 51 186 44 221 133 158 74 175 162 247 208 103 212 148 212 188 213 132 106 117 106 253 106 243 234 58 234 203 213 11 212 91 213 31 105 16 52 24 26 9 26 21 26 221 26 51 154 170 154 1 154 249 154 205 154 247 181 240 90 12 173 36 173 61 90 189 90 115 218 58 218 17 218 91 180 59 180 39 117 228 117 124 116 242 116 154 117 30 234 146 117 157 116 87 235 214 235 222 210 195 232 49 244 82 244 246 235 221 208 135 245 173 244 147 244 107 244 7 12 96 3 107 3 174 193 126 131 65 67 180 161 173 33 207 176 222 112 216 136 100 228 98 148 101 212 108 52 106 76 51 246 55 46 48 238 48 126 97 162 105 18 109 178 211 164 215 228 147 169 149 105 170 105 131 233 3 51 25 51 95 179 2 179 46 179 223 205 245 205 89 230 53 230 183 44 200 22 158 22 235 45 58 45 94 90 26 88 114 44 15 88 222 181 162 88 5 88 109 177 234 182 250 104 109 99 205 183 110 177 158 178 209 180 137 179 217 103 51 204 160 50 130 24 165 140 43 182 104 91 87 219 245 182 167 109 223 217 89 219 9 236 78 216 253 102 111 100 159 98 127 212 126 114 169 206 82 206 210 134 165 99 14 234 14 76 135 58 135 17 71 186 99 156 227 65 199 17 39 53 39 166 83 189 211 19 103 13 103 182 115 163 243 132 139 158 75 178 203 49 151 23 174 166 174 124 215 54 215 57 55 59 183 181 110 231 221 17 119 47 247 98 247 126 15 25 143 229 30 213 30 143 61 213 61 19 61 155 61 103 188 172 188 214 120 157 247 70 123 251 121 239 244 30 246 81 246 97 249 52 249 204 248 218 248 174 245 237 241 35 249 133 250 85 251 61 241 215 247 231 251 119 5 192 1 190 1 187 2 30 46 211 90 198 91 214 17 8 2 125 2 119 5 62 10 210 9 90 29 244 99 48 38 56 40 184 38 248 105 136 89 72 126 72 111 40 37 52 54 244 104 232 155 48 215 176 178 176 7 203 117 151 11 151 119 135 75 134 199 132 55 133 207 69 184 71 148 71 140 68 154 68 174 141 188 30 165 24 197 141 234 140 198 70 135 71 55 70 207 174 240 88 177 123 197 120 140 85 76 81 204 157 149 58 43 115 86 94 93 165 184 42 117 213 153 88 201 88 102 236 201 56 116 92 68 220 209 184 15 204 64 102 61 115 54 222 39 126 95 252 12 203 141 181 135 245 156 237 204 174 96 79 113 28 56 229 156 137 4 135 132 242 132 201 68 135 196 93 137 83 73 78 73 149 73 211 92 55 110 53 247 101 178 119 114 109 242 92 74 96 202 225 148 133 212 136 212 214 52 92 90 92 218 41 158 12 47 133 215 147 174 146 158 147 62 152 97 144 81 148 49 178 218 110 245 238 213 51 124 63 126 99 38 148 185 50 179 83 64 21 253 76 245 9 117 133 155 133 163 89 142 89 53 89 111 179 195 179 79 230 72 231 240 114 250 114 245 115 183 229 78 228 121 230 125 187 6 181 134 181 166 59 95 45 127 99 254 232 90 151 181 117 235 160 117 241 235 186 215 107 172 47 92 63 190 193 107 195 145 141 132 141 41 27 127 42 48 45 40 47 120 189 41 98 83 87 161 114 225 134 194 177 205 94 155 155 139 36 138 248 69 195 91 236 183 212 110 69 109 229 110 237 223 102 177 109 239 182 79 197 236 226 107 37 166 37 149 37 31 74 89 165 215 190 49 251 166 234 155 133 237 9 219 251 203 172 203 14 236 192 236 224 237 184 179 211 105 231 145 114 233 242 188 242 177 93 1 187 218 43 232 21 197 21 175 119 199 238 190 90 105 89 89 187 135 176 71 184 103 164 202 191 170 115 175 230 222 29 123 63 84 39 85 223 174 113 173 105 221 167 180 111 219 190 185 253 236 253 67 7 156 15 180 212 42 215 150 212 190 63 200 61 120 183 206 171 174 189 94 187 190 242 16 230 80 214 161 167 13 225 13 189 223 50 190 109 106 84 108 44 105 252 120 152 119 120 228 72 200 145 158 38 155 166 166 163 74 71 203 154 225 102 97 243 212 177 152 99 55 190 115 255 174 179 197 168 165 174 149 214 90 114 28 28 23 30 127 246 125 220 247 119 78 248 157 232 62 201 56 217 242 131 214 15 251 218 40 109 197 237 80 123 110 251 76 71 82 199 72 103 84 231 224 41 223 83 221 93 246 93 109 63 26 255 120 248 180 218 233 154 51 178 103 202 206 18 206 22 158 93 56 151 119 110 246 124 198 249 233 11 137 23 198 186 99 187 31 92 140 188 120 171 39 184 167 255 146 223 165 43 151 61 47 95 236 117 233 61 119 197 225 202 233 171 118 87 79 93 99 92 235 184 110 125 189 189 207 170 175 237 39 171 159 218 250 173 251 219 7 108 6 58 111 216 222 232 26 92 58 120 118 200 105 232 194 77 247 155 151 111 249 220 186 126 123 217 237 193 59 203 239 220 29 142 25 30 185 203 190 59 121 47 245 222 203 251 89 247 231 31 108 120 136 126 88 252 72 234 81 229 99 165 199 245 63 235 253 220 58 98 61 114 102 212 125 180 239 73 232 147 7 99 172 177 231 191 100 254 242 97 188 240 41 249 105 229 132 234 68 211 164 249 228 233 41 207 169 27 207 86 60 27 127 158 241 124 126 186 232 87 233 95 247 189 208 125 241 195 111 206 191 245 205 68 206 140 191 228 191 92 248 189 244 149 194 171 195 175 45 95 119 207 6 205 62 126 147 246 102 126 174 248 173 194 219 35 239 24 239 122 223 71 188 159 152 207 254 128 253 80 245 81 239 99 215 39 191 79 15 23 210 22 22 254 5 3 152 243 252 170 199 106 190 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 14 157 73 68 65 84 104 129 229 154 107 140 93 87 117 199 127 107 237 125 238 140 103 60 30 63 226 56 198 60 18 7 59 1 219 4 251 222 59 177 93 82 102 242 161 65 73 133 154 54 247 10 218 242 106 16 9 162 72 105 42 85 137 34 37 68 21 168 170 84 104 105 139 2 17 20 241 104 83 79 3 136 82 90 18 232 12 165 109 108 223 51 38 15 55 56 184 16 94 33 241 43 142 51 137 61 51 247 236 189 250 225 238 51 190 25 223 177 3 82 16 21 75 58 154 51 231 236 189 246 218 255 245 220 235 92 49 51 126 33 212 108 58 118 237 10 0 255 117 233 101 151 68 120 179 96 99 6 27 13 94 9 180 5 217 239 69 110 223 241 157 7 191 134 136 98 22 127 49 194 189 56 146 95 4 88 227 210 116 13 219 21 246 108 217 178 166 221 214 15 70 236 247 135 156 235 51 131 182 25 115 9 147 229 206 115 34 20 79 103 153 189 246 242 71 30 57 52 46 226 26 102 225 37 23 240 69 146 127 169 23 40 55 188 123 227 150 215 180 85 191 190 220 185 151 157 8 5 211 33 20 157 17 34 128 3 138 227 161 112 2 131 97 134 165 192 161 70 163 241 82 139 247 51 209 75 11 150 136 148 150 209 86 249 216 176 115 47 59 30 138 25 160 79 192 119 108 218 12 40 0 89 237 51 57 86 180 63 191 243 224 35 223 187 83 68 239 248 37 178 42 120 233 45 75 0 123 224 146 215 175 67 216 254 108 8 229 179 96 96 102 168 19 220 18 117 222 48 142 21 237 79 21 107 87 221 240 18 203 244 115 147 158 107 128 36 58 215 123 17 233 197 203 0 118 60 246 224 19 24 95 28 118 142 33 231 250 150 57 239 135 189 207 134 189 119 17 56 25 227 127 78 155 93 247 134 3 15 95 63 58 49 81 208 177 170 23 21 220 203 181 23 92 139 202 219 53 79 155 205 166 235 53 182 235 221 11 246 180 168 101 141 141 141 121 0 51 43 74 6 214 181 129 59 239 188 83 39 39 39 21 8 214 201 18 38 34 218 104 52 100 87 202 122 152 25 34 130 153 125 110 168 242 142 198 243 115 95 169 192 142 254 200 208 50 177 35 75 131 60 248 122 229 1 30 123 232 251 37 223 27 106 181 236 227 102 237 115 1 52 58 58 234 186 228 59 35 75 141 141 141 249 201 201 201 82 182 133 207 205 186 92 92 68 164 28 215 108 54 221 130 119 154 214 137 152 217 252 5 200 232 232 168 39 101 201 133 23 29 23 146 209 209 81 223 235 125 121 53 26 13 7 72 163 209 112 163 163 163 222 122 240 227 138 203 95 151 141 140 252 225 186 122 237 227 155 235 213 187 47 169 215 223 69 226 75 163 225 22 89 95 123 173 253 234 87 191 186 111 203 150 45 43 118 236 216 177 178 90 173 14 44 156 211 107 95 213 106 53 27 25 25 89 181 112 111 229 125 181 90 93 91 173 86 135 187 247 36 73 249 58 58 58 170 19 19 19 69 137 104 189 94 223 108 102 215 138 200 175 155 89 136 49 222 188 111 223 190 71 75 45 140 140 140 92 16 99 108 136 200 168 153 173 75 230 252 152 170 126 116 207 158 61 121 183 182 0 106 181 218 197 39 68 222 232 197 174 92 29 248 181 151 27 23 94 44 202 154 104 44 139 198 115 2 95 117 236 203 189 187 238 169 61 123 30 111 54 155 110 222 66 147 69 148 242 213 106 181 76 85 223 24 99 188 18 168 210 169 211 150 165 13 63 15 124 87 85 255 97 239 222 189 159 91 104 113 35 35 35 59 99 140 239 4 46 7 94 37 34 255 118 209 69 23 253 94 185 86 189 94 255 29 51 187 3 88 11 204 1 247 121 239 111 217 189 123 247 33 105 52 26 47 16 170 94 175 95 13 220 104 102 87 121 239 43 49 70 178 44 99 118 118 246 147 121 158 191 59 9 251 126 224 118 231 220 121 229 60 51 67 85 41 138 2 85 125 203 222 189 123 255 177 94 175 143 40 92 61 13 99 125 176 245 53 145 161 122 48 46 109 7 86 133 64 197 40 12 172 13 12 153 241 207 75 251 179 191 115 236 123 203 169 83 59 238 216 191 127 46 41 160 212 120 184 236 178 203 6 179 44 187 65 68 222 5 108 86 85 186 244 49 79 34 130 136 16 66 248 92 171 213 122 219 206 157 59 151 204 206 206 254 182 136 188 13 184 202 123 79 140 113 126 108 8 225 55 243 60 255 151 90 173 118 141 170 126 69 68 230 223 123 239 105 183 219 15 123 239 175 16 51 163 86 171 13 0 239 4 174 87 213 109 229 224 228 187 133 170 246 197 24 247 171 234 251 98 140 127 226 189 191 38 198 72 140 49 112 58 94 8 16 84 181 18 99 60 14 124 85 224 119 67 150 201 166 185 130 55 207 180 217 90 196 184 2 98 0 153 17 116 22 100 14 120 94 32 139 216 191 87 180 248 236 96 127 214 31 194 245 187 91 173 79 109 216 176 161 239 224 193 131 179 93 26 255 115 239 253 250 180 118 4 52 133 196 34 173 95 82 4 50 231 28 33 132 207 139 200 38 231 220 235 205 140 208 201 200 229 248 194 123 223 23 66 184 185 213 106 125 164 94 175 63 166 170 27 67 8 51 64 37 237 173 157 101 89 127 187 221 254 83 169 86 171 91 68 228 159 84 117 163 153 17 99 44 235 30 191 64 0 84 59 201 33 198 88 46 230 206 80 43 4 192 101 206 241 124 140 212 218 161 125 203 169 66 214 153 105 91 69 67 105 42 73 146 8 180 233 212 18 119 247 185 226 139 3 125 190 63 132 123 247 182 90 215 117 89 251 71 84 245 166 36 95 65 39 153 100 102 54 3 252 88 68 54 244 176 48 3 162 115 206 165 121 165 98 93 215 190 162 170 170 153 61 0 60 36 34 55 150 74 232 222 143 170 186 24 227 119 20 248 132 247 126 99 8 225 84 23 8 217 66 160 18 72 196 24 11 17 241 105 209 94 103 37 7 88 17 66 129 153 253 70 59 102 27 212 124 209 39 106 21 112 21 208 74 103 5 113 224 20 6 128 62 224 105 17 137 49 34 102 111 216 190 125 251 50 128 90 173 246 5 239 253 77 33 4 75 242 57 32 75 129 183 1 108 50 179 131 73 145 221 69 172 0 46 132 144 246 143 227 76 3 208 24 163 137 200 14 85 189 49 241 63 99 63 105 204 107 124 137 162 170 46 41 253 244 44 100 34 226 205 236 89 78 7 212 94 36 73 48 30 117 66 142 48 172 176 102 224 244 12 49 176 8 86 128 22 112 178 13 199 4 135 69 68 117 77 8 225 242 122 189 254 166 44 203 174 109 183 219 237 196 207 211 113 29 31 66 248 219 60 207 191 2 80 175 215 159 20 145 13 244 86 30 192 156 136 84 22 57 7 75 66 51 168 106 169 132 110 235 138 169 108 250 145 138 200 219 67 8 55 152 217 61 169 62 91 108 193 224 156 19 224 51 67 67 67 107 128 187 157 115 240 66 109 158 70 149 142 121 126 181 226 120 95 127 133 207 7 71 244 160 67 192 32 200 32 200 64 231 222 13 194 179 30 158 22 65 193 82 188 188 203 204 110 238 224 52 111 17 17 240 41 137 124 26 96 219 182 109 175 2 54 39 69 119 187 79 145 228 187 11 88 7 124 253 44 242 138 136 100 49 198 125 102 118 40 213 86 101 253 54 235 156 67 68 190 169 173 86 235 177 189 123 247 126 162 40 138 247 154 217 51 169 34 94 200 48 136 136 11 33 60 169 170 55 79 76 76 204 136 200 120 87 29 211 91 101 233 229 51 42 156 82 112 75 128 165 9 168 174 75 7 224 168 10 39 68 240 201 232 68 100 125 23 238 165 5 155 170 34 34 255 51 48 48 112 0 64 85 223 174 170 43 83 50 42 193 10 34 226 67 8 115 192 95 231 121 126 212 204 30 78 198 176 208 125 44 129 133 115 238 15 68 228 166 44 203 72 161 70 156 115 75 138 162 32 132 240 81 173 213 106 25 64 140 177 13 28 77 217 101 225 190 45 161 123 239 158 61 123 142 165 103 89 23 38 139 146 1 253 209 184 88 141 190 97 96 64 208 65 57 13 212 32 72 63 28 70 56 41 160 157 165 37 185 66 55 80 208 1 17 224 167 19 19 19 207 213 235 245 173 192 109 201 170 230 131 54 16 189 247 136 200 135 242 60 63 144 158 175 92 76 196 148 253 79 132 16 14 183 90 173 123 218 237 246 93 102 54 7 204 134 16 14 2 215 238 219 183 47 215 169 169 169 0 144 101 153 167 19 103 123 237 215 167 224 254 181 242 97 140 113 93 18 188 76 112 103 144 0 81 160 18 225 101 21 112 203 21 6 21 25 20 100 80 145 129 206 125 204 224 201 8 109 121 129 153 106 15 190 154 92 116 75 173 86 187 21 248 178 170 246 117 89 85 27 80 239 125 86 20 197 103 90 173 214 157 93 115 215 118 85 234 103 128 5 28 7 78 2 180 90 173 247 198 24 55 154 217 214 153 153 153 205 121 158 127 73 68 212 55 26 13 1 80 213 101 49 198 225 30 12 77 58 89 234 132 153 61 50 15 132 200 165 231 136 113 148 72 14 7 99 245 48 176 76 81 3 65 82 205 96 168 9 237 233 200 33 19 76 58 62 120 22 82 51 51 17 185 64 85 63 20 66 32 89 128 3 112 206 101 102 70 81 20 31 206 243 252 143 203 73 99 99 99 253 192 43 23 1 171 44 98 159 201 243 124 58 253 175 102 246 195 242 125 121 94 156 63 72 135 16 86 136 200 210 30 2 90 114 205 31 12 15 15 63 209 245 124 219 89 186 172 157 56 0 4 129 225 8 171 150 129 45 83 164 157 94 68 96 206 80 140 83 81 56 100 114 118 127 238 218 91 170 155 72 241 171 2 157 178 38 132 48 153 92 239 254 18 164 137 137 137 153 233 233 233 117 192 43 22 179 172 244 247 88 87 163 192 154 205 166 3 24 31 31 159 63 116 251 35 71 142 8 128 136 172 74 136 46 100 104 9 249 31 118 157 205 214 2 151 245 200 64 243 64 33 210 57 163 128 172 50 99 120 185 98 131 93 96 5 195 60 184 8 211 5 28 23 200 202 74 245 220 100 102 118 0 56 28 99 124 6 120 216 204 238 159 154 154 250 86 57 160 217 108 186 137 137 137 153 180 183 75 68 100 105 42 184 207 104 37 37 15 57 82 206 75 224 156 145 53 231 45 203 204 86 167 227 193 194 10 182 180 172 121 171 82 213 43 69 100 69 143 177 81 85 53 198 248 24 102 143 170 234 181 22 99 92 163 166 131 171 28 12 8 82 128 40 157 207 19 206 208 34 114 252 20 60 101 194 73 4 143 45 158 94 187 170 233 60 207 55 245 26 48 50 50 242 166 24 227 31 137 200 133 181 90 237 253 121 158 223 103 102 213 174 162 117 97 91 202 210 254 15 1 148 198 211 139 186 39 174 238 74 173 189 208 63 60 143 72 140 55 164 154 101 225 216 194 57 87 137 49 126 204 204 246 163 114 173 20 200 90 143 245 173 20 9 125 138 246 209 177 219 57 67 12 162 10 171 206 19 222 250 84 224 232 108 228 191 189 114 84 132 172 55 96 165 229 95 92 171 213 26 121 158 143 3 212 106 181 97 51 219 46 34 55 138 200 111 169 42 206 57 218 237 246 237 192 125 192 235 22 3 128 211 94 116 20 96 122 122 250 220 96 137 200 154 116 187 80 198 78 20 55 59 63 9 118 187 170 94 145 172 170 27 236 182 170 86 218 237 246 247 167 166 166 254 102 180 90 93 57 29 195 241 138 201 138 181 253 22 253 50 149 144 9 210 39 105 145 136 20 70 104 11 107 55 58 222 123 65 228 249 3 129 31 61 33 252 116 64 232 139 61 171 71 49 179 40 34 125 192 174 90 173 246 109 17 121 26 184 200 57 183 62 117 16 48 179 105 85 29 18 145 199 211 188 77 139 5 247 46 58 103 191 223 175 94 189 218 18 88 231 47 50 198 165 147 250 59 234 245 250 21 34 178 121 65 93 3 208 78 7 91 68 228 250 20 40 143 110 187 188 182 119 192 228 170 243 151 74 36 19 37 90 39 96 37 117 88 76 183 125 130 10 236 125 134 248 189 76 99 159 33 209 76 16 41 15 190 221 164 169 79 38 206 185 173 208 105 15 165 120 52 11 120 239 253 80 81 20 71 139 162 184 101 231 206 157 43 69 228 229 103 1 43 38 185 159 62 23 88 58 62 62 94 250 236 249 139 157 157 146 112 3 34 178 57 221 151 3 3 29 139 202 82 97 247 174 86 171 53 185 115 231 206 37 0 109 175 247 87 16 134 51 34 30 66 27 226 201 72 156 233 76 247 25 44 129 192 227 161 248 218 183 66 252 203 83 153 62 215 231 124 191 58 39 222 171 170 58 58 199 142 130 142 203 151 107 11 16 67 8 115 33 132 153 24 227 108 2 175 223 57 231 67 8 247 155 217 142 7 31 124 240 137 217 217 217 141 102 54 152 228 142 233 10 137 231 156 170 86 66 8 115 102 246 117 128 245 235 215 47 122 64 246 93 233 178 108 228 245 46 48 79 247 245 203 156 37 170 234 84 213 21 69 113 12 120 247 212 212 212 151 82 31 126 14 96 200 252 61 199 117 238 182 111 31 209 21 91 191 91 204 12 92 228 42 29 120 49 59 30 227 225 199 131 255 206 15 112 223 56 166 76 100 25 207 246 133 185 37 69 56 208 134 123 68 228 16 240 65 239 253 5 101 169 176 64 153 42 34 149 84 62 16 66 32 132 240 45 17 249 171 86 171 117 111 215 184 19 34 162 170 74 140 209 151 123 233 106 16 6 224 61 121 158 127 47 85 3 139 186 163 152 25 87 95 125 117 223 145 35 71 166 68 100 83 234 251 116 155 190 165 22 241 15 128 167 129 109 105 225 40 34 63 52 179 47 196 24 63 188 111 223 190 159 54 155 77 55 62 62 30 205 204 164 217 116 182 107 87 120 237 229 181 107 86 206 218 151 175 85 213 234 202 136 207 224 232 73 225 251 207 9 15 207 24 223 85 158 60 188 132 221 3 42 223 56 111 70 38 39 30 106 61 90 182 163 183 111 223 190 166 40 138 247 0 215 0 151 2 195 101 119 52 13 57 14 28 20 145 111 170 234 23 247 236 217 243 64 41 116 119 27 186 94 175 223 102 102 55 209 105 232 181 129 103 128 31 3 187 99 140 159 237 110 151 47 6 212 60 88 181 90 237 60 224 128 136 172 90 208 158 128 78 3 77 99 140 215 181 90 173 123 71 70 70 234 192 48 112 116 112 112 240 127 39 38 38 158 91 40 220 60 243 4 216 134 157 245 173 110 206 110 89 62 75 221 153 245 159 84 126 50 93 145 255 152 30 112 247 251 229 97 234 137 47 231 71 187 231 141 141 141 249 233 233 105 201 243 124 254 43 207 200 200 200 43 204 108 109 140 113 41 128 247 254 89 17 121 106 247 238 221 63 233 158 91 171 213 178 169 169 169 34 85 250 243 0 108 221 186 117 121 165 82 89 17 66 152 153 153 153 153 222 191 127 255 115 229 156 133 253 254 115 129 117 171 170 126 168 71 151 16 58 39 125 137 49 94 149 231 249 125 11 25 148 149 238 98 139 149 128 117 238 199 150 14 205 76 247 63 187 0 156 238 79 91 221 159 175 206 197 187 91 134 35 71 142 72 175 79 95 101 31 223 122 124 135 124 177 252 231 121 85 171 213 155 85 245 47 82 134 91 120 202 135 212 108 43 138 226 214 60 207 255 172 212 250 250 245 235 99 58 10 156 179 99 216 108 54 221 166 241 113 187 163 107 108 249 93 114 114 114 50 210 169 200 23 117 1 17 145 70 163 161 112 186 104 92 189 122 181 109 218 180 201 62 240 129 15 156 117 110 23 15 109 52 26 82 38 180 115 173 217 147 71 173 86 43 231 148 125 247 133 84 118 10 143 139 200 173 121 158 223 157 106 157 115 250 120 47 129 127 94 65 127 25 72 205 108 50 203 50 72 45 91 58 1 176 76 213 229 152 0 44 203 178 236 174 106 181 122 27 64 233 54 63 11 153 89 76 215 255 59 160 0 84 85 223 90 20 197 191 138 8 190 67 153 115 206 107 249 41 167 147 13 93 249 149 132 116 44 248 85 164 249 31 179 213 106 181 109 192 152 136 92 102 102 23 210 233 91 95 72 39 224 31 22 145 135 98 140 127 63 53 53 245 105 120 225 239 3 126 85 232 255 0 156 99 120 0 143 53 132 133 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!PRAdminFileLibrary methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 16:17'!
selectorsToInclude
	^ #( pieradminCss )! !

WAFileLibrary subclass: #PRAdminSetupFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-Core'!

!PRAdminSetupFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 3/5/2012 16:15'!
jqCloneJs
   ^ '/**
 * Copyright (c) 2009  Gary Haran => gary@talkerapp.com
 * Released under MIT license [...]
 */
(function($){
  $.fn.clonePosition = function(element, options){
    var options = $.extend({
      cloneWidth: true,
      cloneHeight: true,
      offsetLeft: 0,
      offsetTop: 0
    }, (options || {}));
    
    var offsets = $(element).offset();
    
    $(this).css({
      position: ''absolute'',
      top:  (offsets.top  + options.offsetTop)  + ''px'',
      left: (offsets.left + options.offsetLeft) + ''px''
    });
    
    if (options.cloneWidth)  $(this).width($(element).width());
    if (options.cloneHeight) $(this).height($(element).height());
    
    return this;
  }
})(jQuery);'! !

!PRAdminSetupFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 3/5/2012 17:14'!
piersetupCss
	^ '
body {
  background: white !!important;
  font-family:Verdana, Helvetica, Geneva, sans-serif;
  font-size:75%;
  height:100%;
}	
	
code {
  font-size: 1.5em;
}
	
.setupAdminUI {
	margin: 10px;
	font-family: Verdana, Helvetica, Geneva, sans-serif;
}

.setupAdminTitleText {
	font-size: 18px;
	color: #69C;
}

#setupAdminExistingKernel, #setupAdminKernelFromTemplate, #setupAdminRecreateExportedKernel {
	float: left;
	width: 300px;
	padding-right: 2px;
	height: 250px;
}

#setupAdminKernelFromTemplate, #setupAdminRecreateExportedKernel {
	border-left: solid 1px;
	border-color: #69C;
	border-width: 2px;
	padding-left: 10px; 
}

.setupAdminPierTitle {
	vertical-align: top;
}

.setupAdminStrapline {
	font-size: 1.3em;
}

.setupAdminOverlayBase {
	z-index:8; 
	background:white; 
	opacity:0.8;
}

.setupAdminOverlayMessage {
	background:black;
	color: white;
	font-weight: bold;
	margin-left: 50px;
	margin-top: 100px;
	padding: 10px;
	display: inline-block;
	border-radius:10px;
	-moz-border-radius:10px;
	-webkit-border-radius:10px; 
	z-index: 10;	
}

.setupAdminStraplineHighlight {
	color: #304D6A;
	font-weight: bold;
}

.setupAdminUI th, .setupAdminUI td {
	text-align: left;
}

.setupAdminUI .buttons {
	margin-top: 10px;
}

.adminLogin h1 {
	font-size: 1.5em;
	line-height: 1;
	margin-bottom: 1em;
  	font-family: font-family: Verdana, Helvetica, Geneva, sans-serif;
}

.adminLogin h4 {
  	font-family: font-family: Verdana, Helvetica, Geneva, sans-serif;
}

.adminLogin h3 {
	text-decoration:underline
}

.adminLogin table {
	margin-bottom: 1.4em;
	width: 100%;
  	font-family: Verdana, Helvetica, Geneva, sans-serif;
}

.adminLogin th {
	background: #eee;
	font-weight: normal;
}

.adminLogin td, .adminLogin th {
	padding: 4px 10px 4px 5px;
	text-align: left;
	font-size: 100%;
	font-weight: normal;
}

.adminLogin label {
	font-weight: normal;
}

.adminLogin h4 {
	margin-bottom: 1.5em;
	font-size: 1em;
	font-weight: normal;
}

.adminLogin h4 {
	margin-bottom: 1.5em;
	font-size: 1em;
	font-weight: normal;
}

.adminLogin td.required::after {
	color: #ff6633;
	content: "*";
	left-margin: 0.5em;
}

.adminLogin .errors {
	color: red;
	font-weight: bold;
}

.adminLogin .error {
	border: 2px solid #fbc2c4;
	color: #8a1f11;
}

.adminLogin th.error, .adminLogin td.error {
	background: #fbe3e4;
	border: 2px solid #fbc2c4;
	color: #8a1f11;
}

'! !

!PRAdminSetupFileLibrary methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 16:15'!
selectorsToInclude
	^ #( jqCloneJs piersetupCss )! !

WAActionPhaseContinuation subclass: #PRAdminActionPhaseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminActionPhaseContinuation commentStamp: 'NickAger 2/13/2012 17:18' prior: 0!
I specialise ==WAActionPhaseContinuation== to allow redirects to be configurable for GET and POST requests by adding the 'dontRedirect' request key. 
Used when rendering Ajax response to ensure the action continuation directly renders a response rather than a redirect.!

!PRAdminActionPhaseContinuation methodsFor: 'private' stamp: 'NickAger 11/23/2011 10:41'!
shouldRedirect
	"in pier admin when we trigger a render request from an Ajax callback we want to render
	the result directly, rather than the rendering a redirect"
	 ^ (self request fields includesKey: 'dontRedirect') not! !

PRContext subclass: #PRAdminContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminContext commentStamp: 'NickAger 11/24/2011 15:11' prior: 0!
PRAdminContext overrides PRContext simply to ensure that bookmarkable Urls aren't generated by Pier within Pier Admin. Why? Pier Admin needs to maintain Seaside's component state.!

!PRAdminContext methodsFor: 'pier-seaside-urls' stamp: 'NickAger 11/23/2011 10:05'!
urlOn: aRenderer
	"Overridden to ensure only the creation of standard Seaside urls (not Pier Restful Urls), within Pier Admin - we need
	 to recover context from _s & _k and can't rely on the path"
	| url |
	^ aRenderer callbacks isNil
		ifTrue: [ self url ]
		ifFalse: [
			url := aRenderer context actionUrl copy.
			url purgeOtherFields; adaptToContext: self.

			url queryFields
				at: '_n' put: nil;
				at: (aRenderer callbacks store: self activationCallback) put: nil.
			url ]! !

WATask subclass: #PRAdminSetupExistingKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-ExistingKernel'!

!PRAdminSetupExistingKernel methodsFor: 'tasks' stamp: 'NickAger 3/5/2012 16:45'!
adminInstanceAlreadyAssociatedWithKernel: kernelPathPair
	PRAdminSetup recursiveDispatcherHandersDo: [ :handler :handlerPath |
		[ (handler isApplication and: [ kernelPathPair = handler pierAdminKernelPathPair ]) ifTrue: [ ^ handlerPath ]
		 ] 
		"no
		      WARequestHandler>>#preferenceAt:ifAbsent: 
	 	so have to handle the exception"
		on: WAAttributeNotFound do: [ :err | "do nothing" ] ].	
	
	^ nil! !

!PRAdminSetupExistingKernel methodsFor: 'tasks' stamp: 'NickAger 3/5/2012 13:42'!
chooseExistingKernel
	^ self call: PRAdminSetupChooseExistingKernel new
! !

!PRAdminSetupExistingKernel methodsFor: 'tasks' stamp: 'NickAger 3/7/2012 08:47'!
confirmAdminInstance: adminInstancePath alreadyAssociatedWith: selectedKernelPathPair
	^ self confirm:  [ : r | 
		r 
			text: 'The kernel you selected: '; break; break;
			text: selectedKernelPathPair; break; break;
			text: 'is already associated with admin instance at:'; break; break;
			code: adminInstancePath; break; break;
			text: 'Do you want to continue by logging into: '; code: adminInstancePath ]! !

!PRAdminSetupExistingKernel methodsFor: 'running' stamp: 'NickAger 3/5/2012 15:14'!
createAdminInstance: selectedKernelPathPair
	^ PRAdminLogin registerForAdministering: selectedKernelPathPair! !

!PRAdminSetupExistingKernel methodsFor: 'running' stamp: 'NickAger 3/6/2012 11:03'!
go
	| selectedKernelPathPair adminInstancePath |
	
	 [ adminInstancePath ] whileNil: [
		selectedKernelPathPair := self chooseExistingKernel.
		adminInstancePath :=  self adminInstanceAlreadyAssociatedWithKernel: selectedKernelPathPair.
		
		adminInstancePath isNil
			ifTrue: [
				adminInstancePath := self createAdminInstance: selectedKernelPathPair.
				self informInstanceCreatedForPath: adminInstancePath kernel: selectedKernelPathPair ] 
		
			ifFalse: [ 
				(self confirmAdminInstance: adminInstancePath alreadyAssociatedWith: selectedKernelPathPair) 
					ifFalse: [ adminInstancePath := nil ] ] ].
			
	self redirectTo: adminInstancePath
! !

!PRAdminSetupExistingKernel methodsFor: 'tasks' stamp: 'NickAger 3/5/2012 15:56'!
informInstanceCreatedForPath: adminInstancePath kernel: selectedKernelPathPair
	self inform: [ :html | 
		html 
			text: 'Admin instance created at: '; break; break;
			code: adminInstancePath; break; break;
			text: 'for: '; break; break;
			text: selectedKernelPathPair; break; break;
			text: 'Continue to redirect to admin instance.' ]! !

!PRAdminSetupExistingKernel methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 11:04'!
redirectTo: path
	self requestContext redirectTo: path! !

WATask subclass: #PRAdminSetupTaskBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-Core'!

PRAdminSetupTaskBase subclass: #PRAdminSetupCreateKernelFromTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-NewKernelFromDistribution'!

!PRAdminSetupCreateKernelFromTemplate commentStamp: 'NickAger 2/29/2012 14:54' prior: 0!
I create a kernel from a selected template and create an admin user with the specified user name and password.
!

!PRAdminSetupCreateKernelFromTemplate methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 14:05'!
chooseDistribution: aBlock
	| choosenDistributionInfo |
	choosenDistributionInfo :=  self call: PRAdminSetupChooseDistribution new.
	
	aBlock 
		value: choosenDistributionInfo selectedDistribution 
		value: choosenDistributionInfo kernelName
		value: choosenDistributionInfo applicationPath
	! !

!PRAdminSetupCreateKernelFromTemplate methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 14:17'!
createKernelNamed: kernelName adminUserNamed: adminUserName adminUserPassword: password
	| kernel adminUser |
	kernel := PRKernel named: kernelName.

	adminUser := ((PUUser named: adminUserName)
		password: password; 
		addGroup: kernel adminGroup;
		superuser: true;
		yourself).
	
	kernel propertyAt: #users put: (Set with: adminUser).
	kernel propertyAt: #adminUser put: adminUser.
	
	^ kernel! !

!PRAdminSetupCreateKernelFromTemplate methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 15:25'!
createSiteAt: dispatcherName forDistribution: selectedDistribution onKernel: kernel
	| distribution |
	distribution := selectedDistribution new.
	distribution showCustomizeUIOn: self thenAddRootToKernel: kernel.
	self registerApplicationAtPath: dispatcherName kernel: kernel
	
! !

!PRAdminSetupCreateKernelFromTemplate methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 14:13'!
defineAdminUser: aBlock
	| adminUserComponent adminUserNamePassword |
	adminUserComponent := PRAdminSetupDefineAdminUser new asComponent 
		addValidatedForm: (Array with: #save -> 'Register admin user'); 
		addMessage: 'Create an admin user';
		yourself.

	adminUserNamePassword := self call: adminUserComponent.
	
	aBlock 
		value: adminUserNamePassword getName  
		value: adminUserNamePassword password ! !

!PRAdminSetupCreateKernelFromTemplate methodsFor: 'running' stamp: 'NickAger 3/7/2012 08:49'!
go
	| kernelName dispatcherName |
	
	self selectAndCreateFromTemplateDistribution: [ :aKernelName :aDispatcherName | kernelName := aKernelName. dispatcherName := aDispatcherName ].
	self queryAdminUICreationFor: kernelName at: dispatcherName
	
! !

!PRAdminSetupCreateKernelFromTemplate methodsFor: 'tasks' stamp: 'NickAger 3/3/2012 09:59'!
registerApplicationAtPath: path kernel: kernel 
	| app |
	app := PRPierFrame registerAsApplication: path kernel: kernel.
	"have to include this lot if you want users to have a rich editing experience in the comments and 
	be able to upload comment files"
	app
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		preferenceAt: #rootDecorationClasses put: #();
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQBaseTheme;
		addLibrary: 	SPHighlightedStyle.

	app
		configuration addParent: NAFileUploadConfigurator instance! !

!PRAdminSetupCreateKernelFromTemplate methodsFor: 'main task' stamp: 'NickAger 3/7/2012 08:49'!
selectAndCreateFromTemplateDistribution: aBlock
	| selectedDistribution kernelName dispatcherName adminUserName adminPassword kernel |
	
	self chooseDistribution: [ :aSelectedDistribution :aKernelName :aDispatcherName | 
		selectedDistribution := aSelectedDistribution.
		kernelName := aKernelName.
		dispatcherName := aDispatcherName ].
	
	self defineAdminUser: [ :anAdminUserName :anAdminPassword | 
		adminUserName := anAdminUserName.
		adminPassword := anAdminPassword ].
	
	kernel := self createKernelNamed: kernelName adminUserNamed: adminUserName adminUserPassword: adminPassword.
	self inform: 'Created admin user named: ''', adminUserName, '''. Continue to create the site.'	.
	self createSiteAt: dispatcherName forDistribution: selectedDistribution onKernel: kernel.
	
	aBlock value: kernelName value: dispatcherName
	
! !

PRAdminSetupTaskBase subclass: #PRAdminSetupRecreateExportedKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-RecreateExportedKernel'!

!PRAdminSetupRecreateExportedKernel methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 10:48'!
confirmReplacementFor: kernelCreator
	^ self confirm: 'An application is already registered at: ''/', kernelCreator dispatcherPathName, ''', if you continue this application will be replaced with the exported kernel. Continue?'.
! !

!PRAdminSetupRecreateExportedKernel methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 10:54'!
createExportedKernel: kernelCreator
	kernelCreator register.
	self inform: 'Kernel (', kernelCreator kernelName, '), path (/', kernelCreator dispatcherPathName, ') created.'! !

!PRAdminSetupRecreateExportedKernel methodsFor: 'tasks' stamp: 'NickAger 3/7/2012 08:49'!
doesKernelAlreadyExistFor: kernelCreator
	| alreadyDefinedDispatcher |
	
	alreadyDefinedDispatcher := (WADispatcher default handlerAt: kernelCreator dispatcherPathName ifAbsent: [ nil ]).
	^ alreadyDefinedDispatcher notNil! !

!PRAdminSetupRecreateExportedKernel methodsFor: 'running' stamp: 'NickAger 3/6/2012 15:22'!
go
	| kernelCreator |
	
	 [ kernelCreator ] whileNil: [
		kernelCreator := self selectExportedKernelComponent.
		(self doesKernelAlreadyExistFor: kernelCreator) ifTrue: [
			(self confirmReplacementFor: kernelCreator) 
				ifTrue: [ self removePreviousRegisterInstance: kernelCreator ]
				ifFalse: [ kernelCreator := nil ] ] ].
		
	self createExportedKernel: kernelCreator.
	self queryAdminUICreationFor: kernelCreator kernelName at: kernelCreator dispatcherPathName! !

!PRAdminSetupRecreateExportedKernel methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 10:52'!
removePreviousRegisterInstance: kernelCreator
	| alreadyDefinedDispatcher existingKernel |
	
	alreadyDefinedDispatcher := WADispatcher default handlerAt: kernelCreator dispatcherPathName.
		
	[ existingKernel := alreadyDefinedDispatcher preferenceAt: #kernel ] on: WAAttributeNotFound do: [ :err | "do nothing" ].
	existingKernel notNil ifTrue: [
		PRKernel instances remove: alreadyDefinedDispatcher ifAbsent: [ nil ] ].
	
	WAAdmin unregister: kernelCreator dispatcherPathName! !

!PRAdminSetupRecreateExportedKernel methodsFor: 'tasks' stamp: 'NickAger 3/6/2012 11:42'!
selectExportedKernelComponent
	| selectedExportedKernelClass |
	selectedExportedKernelClass :=  self call: PRAdminSetupSelectExportedKernel new.
	^ selectedExportedKernelClass new! !

!PRAdminSetupTaskBase class methodsFor: 'constants' stamp: 'NickAger 3/6/2012 15:08'!
containerId
	^ #setupAdminKernelFromTemplate! !

!PRAdminSetupTaskBase methodsFor: 'admin ui tasks' stamp: 'NickAger 3/6/2012 15:08'!
confirmCreateAdminInstanceFor: kernelName at: dispatcherName
	| adminInstanceDispatcherName answer |
	adminInstanceDispatcherName := dispatcherName, '-admin'.
	
	answer := self confirm: [ :html | 
		html 
			text: 'Create a Pier Admin instance to manage the recreated kernel (', kernelName, '), path (/', dispatcherName, ')?' ; break;
			text: 'The admin instance will be created at: '; break; break;
			code: [ html text: '/'; text: adminInstanceDispatcherName ]; break; break;
			text: 'Create Pier Admin instance?' ].
		
	^ answer
		ifTrue: [ adminInstanceDispatcherName ] 
		ifFalse: [ nil ]! !

!PRAdminSetupTaskBase methodsFor: 'admin ui tasks' stamp: 'NickAger 3/6/2012 15:08'!
createAdminInstanceFor: kernelName dispatcher: dispatcherName at: adminInstancePath
	| kernelPathPair kernel |
	
	kernel := PRKernel instanceNamed: kernelName.
	kernelPathPair := PRAdminKernelPathPair kernel: kernel path: dispatcherName.
	
	PRAdminLogin registerAt: adminInstancePath administering: kernelPathPair! !

!PRAdminSetupTaskBase methodsFor: 'admin ui tasks' stamp: 'NickAger 3/6/2012 15:08'!
informAdminInstanceCreatedAt: adminInstancePath
	self inform: [ :html | 
		html 
			text: 'A Pier Admin instance has been created at: ' ; break; break;
			code: [ html text: '/'; text: adminInstancePath ]; break; break;
			text: 'Continue to login.' ]! !

!PRAdminSetupTaskBase methodsFor: 'admin ui tasks' stamp: 'NickAger 3/6/2012 15:08'!
informRedirectTo: path
	self inform: [ :html | 
		html 
			text: 'Continue to redirect to: ' ; break; break;
			code: [ html text: '/'; text: path ] ]! !

!PRAdminSetupTaskBase methodsFor: 'admin ui task main' stamp: 'NickAger 3/6/2012 15:10'!
queryAdminUICreationFor: kernelName at: dispatcherName
	| adminInstancePath |
	(adminInstancePath := self confirmCreateAdminInstanceFor: kernelName at: dispatcherName) notNil 
		ifTrue: [
			self createAdminInstanceFor: kernelName dispatcher: dispatcherName at: adminInstancePath.
			self informAdminInstanceCreatedAt: adminInstancePath.
			self redirectTo: adminInstancePath ]
		ifFalse: [
			self informRedirectTo: dispatcherName.
			self redirectTo: dispatcherName ]! !

!PRAdminSetupTaskBase methodsFor: 'admin ui tasks' stamp: 'NickAger 3/6/2012 15:08'!
redirectTo: path
	self requestContext redirectTo: path! !

GRObject subclass: #PRAdminSetupDefineAdminUser
	instanceVariableNames: 'password name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-NewKernelFromDistribution'!

!PRAdminSetupDefineAdminUser methodsFor: 'accessing' stamp: 'NickAger 3/2/2012 13:56'!
getName
	"not named #name to avoid overriding Object>>#name"
	^ name! !

!PRAdminSetupDefineAdminUser methodsFor: 'accessing' stamp: 'NickAger 3/2/2012 13:55'!
name: anObject
	name := anObject! !

!PRAdminSetupDefineAdminUser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/3/2012 11:24'!
nameDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: (MASelectorAccessor read: #getName write: #name:);
		label: 'Name';
		priority: 100;
		beRequired;
		yourself! !

!PRAdminSetupDefineAdminUser methodsFor: 'accessing' stamp: 'NickAger 3/2/2012 11:43'!
password
	^ password! !

!PRAdminSetupDefineAdminUser methodsFor: 'accessing' stamp: 'NickAger 3/2/2012 11:43'!
password: anObject
	password := anObject! !

!PRAdminSetupDefineAdminUser methodsFor: 'magritte descriptions' stamp: 'NickAger 3/3/2012 11:24'!
passwordDescription
	<magritteDescription>
	^ MAPasswordDescription new
		parameterName: 'password';
		accessor: #password;
		componentClass: MAVerifiedPasswordComponent;
		label: 'Password';
		priority: 200;
		beRequired;
		yourself! !

MASelectListComponent subclass: #PRAdminSetupExportedKernelsSelect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-RecreateExportedKernel'!

!PRAdminSetupExportedKernelsSelect methodsFor: 'rendering' stamp: 'NickAger 3/3/2012 18:47'!
renderEditorOn: html
	| notificationId callbackExportedKernelClass |
	notificationId := html nextId.
	
	"valueholder for Gemstone 2.4.* compatibility see:
	- http://code.google.com/p/glassdb/issues/detail?id=221
	- http://forum.world.st/use-of-method-temporaries-in-callback-blocks-td2340788.html"
	callbackExportedKernelClass := WAValueHolder new. 

	html select
		onChange: (html jQuery ajax callback: [ :val | callbackExportedKernelClass contents: (self options at: (val greaseInteger)) ] value: (html jQuery this value); 
			script: [ :s | s << (s jQuery id: notificationId) html: [ :r | self renderExportedKernelClass: callbackExportedKernelClass contents on: r ] ]);
		list: self options;
		selected: self value;
		callback: [ :value | self value: value ];
		labels: [ :value | self labelForOption: value ].
		
	html div
		id: notificationId;
		with: [ 
			self renderExportedKernelClass: self value on: html ]! !

!PRAdminSetupExportedKernelsSelect methodsFor: 'rendering' stamp: 'NickAger 3/7/2012 12:46'!
renderExportedKernelClass: class on: html
	| exportedKernelCreator |
	class isNil ifTrue: [ ^ self ].
	
	exportedKernelCreator := class new.

	html div: [
		html text: 'kernel name: ('; strong: exportedKernelCreator kernelName; text: ')' ].
	html div: [
		html text: 'path: ('; strong: '/'; strong: exportedKernelCreator dispatcherPathName; text: ')' ]
! !

!PRStructure class methodsFor: '*pier-admin' stamp: 'NickAger 2/14/2012 11:41'!
emptyEnvironment
	^ (PRComponent named: 'emptyEnvironment') prototypeInstance: PRContentsWidget new; yourself! !

!PRStructure methodsFor: '*pier-admin' stamp: 'NickAger 2/14/2012 11:27'!
descriptionEditingEnvironment
	<magritteDescription>
	^ PRStructureDescription new
		accessor: #localEditingEnvironment;
		group: 'Layout Settings';
		label: 'Editing Template';
		priority: 810;
		beSetting;
		yourself! !

!PRStructure methodsFor: '*pier-admin' stamp: 'NickAger 2/13/2012 18:21'!
editingEnvironment
	"Answer the (inherited) environment structure of the receiver, if none is available a default one is created."

	^ self localEditingEnvironment ifNil: [
		self isRoot
			ifTrue: [ self localEditingEnvironment: self class emptyEnvironment ]
			ifFalse: [ self parent editingEnvironment ] ]! !

!PRStructure methodsFor: '*pier-admin' stamp: 'NickAger 2/11/2012 22:35'!
localEditingEnvironment
	^ self propertyAt: #localEditingEnvironment ifAbsent: [ nil ]! !

!PRStructure methodsFor: '*pier-admin' stamp: 'NickAger 2/12/2012 07:57'!
localEditingEnvironment: aStructure
	self propertyAt: #localEditingEnvironment put: aStructure! !

!JQueryInstance methodsFor: '*pier-admin' stamp: 'NickAger 3/1/2012 14:26'!
clonePosition:  element
	self call: 'clonePosition' with: element! !

!WACallbackRegistry methodsFor: '*pier-admin' stamp: 'NickAger 9/29/2011 09:04'!
key: aKey
	nextKey := aKey ! !

Announcement subclass: #PRAdminAjaxUpdate
	instanceVariableNames: 'script'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminAjaxUpdate commentStamp: 'NickAger 2/13/2012 17:18' prior: 0!
I am an ==Announcement== and hold a script which components write to to update themselves.!

!PRAdminAjaxUpdate class methodsFor: 'instance creation' stamp: 'NickAger 11/9/2011 22:29'!
script: script
	^ self new
		script: script;
		yourself! !

!PRAdminAjaxUpdate methodsFor: 'accessing' stamp: 'NickAger 11/9/2011 22:28'!
script
	^ script! !

!PRAdminAjaxUpdate methodsFor: 'accessing' stamp: 'NickAger 11/9/2011 22:28'!
script: anObject
	script := anObject! !

!WAScriptElement methodsFor: '*pier-admin' stamp: 'NickAger 9/29/2011 11:51'!
scriptContents
	| document |
	"if the script element is loading an external file, return the url (ensuring that it's a WAUrl)"
	self attributes at: 'src' ifPresent: [ :url | 
		^ url isString 
			ifTrue: [ WAUrl absolute: url ]
			ifFalse: [ url ] ].
	
	"otherwise just return the contents of the Url"
	document := WAHtmlDocument new.
	self childrenDo: [ :each | document nextPutAll: each greaseString ].

	^ document stream contents! !

!WAApplication methodsFor: '*pier-admin' stamp: 'NickAger 12/5/2011 14:52'!
pierAdminCommands
	^ (self preferenceAt: #pierAdminCommands) collect: [ :each | 
		each isSymbol 
			ifTrue: [ self class environment at: each ] 
			ifFalse: [ each ] ]
! !

!WAApplication methodsFor: '*pier-admin' stamp: 'NickAger 3/5/2012 14:53'!
pierAdminKernelPathPair
	^ self preferenceAt: #pierAdminKernelPathPair! !

!WAApplication methodsFor: '*pier-admin' stamp: 'NickAger 3/5/2012 14:53'!
pierAdminKernelPathPair: kernelPathPair
	^ self preferenceAt: #pierAdminKernelPathPair put: kernelPathPair! !

!WAApplication methodsFor: '*pier-admin' stamp: 'NickAger 12/5/2011 14:51'!
pierAdminViews
	| adminViews |
	adminViews := OrderedCollection withAll: (self preferenceAt: #pierAdminViews).
	adminViews addFirst: #PRDefaultView.
	
	^ adminViews collect: [ :each | 
		each isSymbol 
			ifTrue: [ self class environment at: each ] 
			ifFalse: [ each ] ]
! !

!JQAjax methodsFor: '*pier-admin' stamp: 'NickAger 9/23/2011 18:35'!
callbackId
	^ callbackId! !

WAComponent subclass: #PRAdminAnnouncingComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminAnnouncingComponent commentStamp: 'NickAger 2/13/2012 17:16' prior: 0!
I am the base for all admin ui components and provide common announcement support.!

!PRAdminAnnouncingComponent methodsFor: 'announcing' stamp: 'NickAger 11/18/2011 17:15'!
announceAjaxUpdate: script
	self session pierAdminAnnouncer announce: (PRAdminAjaxUpdate script: script)
! !

!PRAdminAnnouncingComponent methodsFor: 'announcing' stamp: 'NickAger 11/18/2011 17:22'!
announceAjaxUpdateWithoutSelfOn: script
	self announcementUnregister.
	self announceAjaxUpdate: script.
	self announcementRegister! !

!PRAdminAnnouncingComponent methodsFor: 'announcing' stamp: 'NickAger 11/17/2011 13:30'!
announcementRegister
	self subclassResponsibility! !

!PRAdminAnnouncingComponent methodsFor: 'announcing' stamp: 'NickAger 11/17/2011 13:29'!
announcementUnregister
	self session pierAdminAnnouncer unsubscribe: self! !

!PRAdminAnnouncingComponent methodsFor: 'initialization' stamp: 'NickAger 11/17/2011 13:29'!
initialize
	super initialize.
	self announcementRegister! !

PRAdminAnnouncingComponent subclass: #PRAdminUI
	instanceVariableNames: 'commandsComponent tabsComponent navigatorComponent pierComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminUI commentStamp: 'NickAger 2/13/2012 17:15' prior: 0!
I render Pier's administration interface and manage the components contained within it. I manage anchor clicks and form submissions from the main frame component which are intercepted and packaged as Ajax requests and render a response. The response is split-up into:
- head scripts
- head styles
- body scripts
- body html

see also: +value:source|class=PRBookKernelDistribution|selector=bookEntryPierAdminInsideAjaxUpdates+!

!PRAdminUI class methodsFor: 'instance creation' stamp: 'NickAger 2/14/2012 00:01'!
pierComponent: pierComponent
	^ self new
		pierComponent: pierComponent;
		yourself! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 2/13/2012 22:23'!
addHeadScriptsAndStyles: anHtmlRoot on: script
	anHtmlRoot styles do: [ :each | 
		script << (JSStream on: ('addStyleIfNotAlreadyInstalled(', each asJavascript, ')')) ].

	anHtmlRoot scripts do: [ :each |
		each isString 
			ifTrue: [
				script << (JSStream on: ('addScriptIfNotAlreadyInstalled(', each asJavascript, ')')) ]
			ifFalse: [
				script << (JSStream on: ('addScriptUrlIfNotAlreadyInstalled(', each asJavascript, ')')) ] ]
! !

!PRAdminUI methodsFor: 'renderering hijax' stamp: 'NickAger 11/9/2011 20:19'!
addIFrameHeadScriptsAndStyles: htmlRoot on: script
	htmlRoot styles do: [ :each | 
		script << (JSStream on: ('addIFrameStyleIfNotAlreadyInstalled(',  each asJavascript, ')')) ].
	
	htmlRoot scripts do: [ :each |
		each isString
			ifTrue: [
				script << (JSStream on: ('addIFrameScriptIfNotAlreadyInstalled(', each asJavascript, ')')) ]
			ifFalse: [
				script <<  (JSStream on: ('addIFrameScriptUrlIfNotAlreadyInstalled(', each asJavascript, ')')) ] ]
		
! !

!PRAdminUI methodsFor: 'javscript' stamp: 'NickAger 11/9/2011 17:39'!
addIFrameScriptIfNotAlreadyInstalledJS
	^ '
var alreadyInstalledIFrameScripts = [];
var addIFrameScriptUrlIfNotAlreadyInstalled = function (url) {
	if ($.inArray(url, alreadyInstalledIFrameScripts) == -1) {
		/* set cache to true to ensure jQuery doesnt add random query parameters to end of request
		async is false to force the scripts to load in the order they are specified */
		$.ajax({"url":url,"async":false,"dataType":"script","cache":true, "success":function(script){evalScriptWithinIFrame(script)}});
		alreadyInstalledIFrameScripts.push(url);
	}
}
var addIFrameScriptIfNotAlreadyInstalled = function (script) {
	if ($.inArray(script, alreadyInstalledIFrameScripts) == -1) {
		evalScriptWithinIFrame (script);
		alreadyInstalledIFrameScripts.push(script);
	}
}

var evalScriptWithinIFrame = function(script) {
	try {
		jQuery("#iFrameView")[0].contentWindow.eval(script);
	} catch(e) {
		console.log("Error occurred: ");
		console.log(e);
		console.log("while evaluating");
		console.log(script);
		debugger;		
	}
}
'! !

!PRAdminUI methodsFor: 'javscript' stamp: 'NickAger 11/9/2011 20:18'!
addIFrameStyleIfNotAlreadyInstalledJS
	^ '
var alreadyInstalledIFrameStyles = [];

var addIFrameStyleIfNotAlreadyInstalled = function (style) {
	if ($.inArray(style, alreadyInstalledIFrameStyles) == -1) {
		$("#iFrameView").contents().find("head").append(style);
		alreadyInstalledIFrameStyles.push(style);
	}
}
'! !

!PRAdminUI methodsFor: 'javscript' stamp: 'NickAger 2/13/2012 23:06'!
addScriptIfNotAlreadyInstalledJS
	| initiallyLoadedHeadScripts installedScripts |
	initiallyLoadedHeadScripts := self requestContext headScripts asJavascript.
	installedScripts := 'var alreadyInstalledScripts = ', initiallyLoadedHeadScripts, ';'.
	
	^ installedScripts, '
var addScriptUrlIfNotAlreadyInstalled = function (url) {
	if ($.inArray(url, alreadyInstalledScripts) == -1) {
		/* set cache to true to ensure jQuery doesnt add random query parameters to end of request
		async is false to force the scripts to load in the order they are specified */
		$.ajax({"url":url,"async":false,"dataType":"script","cache":true, "success":function(script) {
			try {
				window.eval(script);
			} catch(e) {
				console.log("Error occurred: ");
				console.log(e);
				console.log("while evaluating");
				console.log(script);
				debugger;					
			}
		}});
		alreadyInstalledScripts.push(url);
	}
}
var addScriptIfNotAlreadyInstalled = function (script) {
	if ($.inArray(script, alreadyInstalledScripts) == -1) {
		window.eval(script);
		alreadyInstalledScripts.push(script);
	}
}
'! !

!PRAdminUI methodsFor: 'javscript' stamp: 'NickAger 2/13/2012 15:42'!
addStyleIfNotAlreadyInstalledJS
	| initiallyLoadedHeadStyles installedStyles |
	initiallyLoadedHeadStyles := self requestContext headStyles asJavascript.
	installedStyles := 'var alreadyInstalledStyles = ',  initiallyLoadedHeadStyles, ';'.
	
	^ installedStyles, '
var addStyleIfNotAlreadyInstalled = function (style) {
	if ($.inArray(style, alreadyInstalledStyles) == -1) {
		$("head").append(style);
		alreadyInstalledStyles.push(style);
	}
}
'! !

!PRAdminUI methodsFor: 'announcing' stamp: 'NickAger 2/13/2012 23:04'!
announcementRegister
	self session pierAdminAnnouncer on: PRAdminAjaxUpdate do: [ :ajaxUpdate |
		| s |
		s := ajaxUpdate script.
		self renderHeadScriptsAndStylesOn: s.
		
		"deliberately replace the contents of css '#content ' so that #delegate:on:do: anchors and 
		buttons will be reset and new ones redelegated (as those anchors and buttons are 
		delegated via '#content')"
		s << (s jQuery: #content) replaceWith:  [ :r | self renderViewContentOn: r ] ]! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 2/14/2012 00:02'!
children
	^ Array 
		with: self pierComponent
		with: self navigatorComponent
		with: self commandsComponent
		with: self tabsComponent! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 11/17/2011 13:56'!
commandsComponent
	^ commandsComponent ifNil: [ commandsComponent := PRAdminCommands contextGetCallback: [ self context ] contextSetCallback: [ :newContext | self context: newContext ] ]! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 3/7/2012 08:49'!
context
	^ self pierComponent context! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 3/7/2012 08:49'!
context: newContext
	^ self pierComponent context: newContext! !

!PRAdminUI methodsFor: 'private' stamp: 'NickAger 11/18/2011 16:59'!
ensureThatKeysOnMainPageAndPreviewIFrameDontClashOn: html
	"why? iframe content (preview view) and the main site content share the same message loop (to 
	ensure that changes made to one effect the other). Need a way to ensure that callback keys 
	between the iframe and the wrapper don't clash' "
	html context callbacks key: 1000.! !

!PRAdminUI methodsFor: 'renderering hijax' stamp: 'NickAger 11/23/2011 10:39'!
generateRequestContextFor: callbackUrl requestType: requestType callbackId: callbackId
	| requestContext newRequest newRequestContext postFields callbackUrlString |
	requestContext := self requestContext.
	callbackUrlString := callbackUrl greaseString.

	"ensure the action continuation directly renders a response rather than a redirect
	see: PRAdminActionPhaseContinuation"
	callbackUrl queryFields at: 'dontRedirect' put: 'true'.
	newRequest := WARequest method: requestType uri: callbackUrl.
	
	"purge the request of Seaside fields; _s _k
	these fields are associated with the Ajax request.
	The _k field we require is encoded in the callbackUrl"
	postFields := requestContext request postFields.
	postFields 
		removeKey: self application keyField ifAbsent: [ "do nothing" ];
		removeKey: self session actionField ifAbsent: [ "do nothing" ].
	
	"remove the key which has triggered this Ajax request - to avoid recursion"
	postFields removeKey: callbackId ifAbsent: [ "do nothing" ].
	
	"remove the key containing the url"
	postFields copy keysAndValuesDo: [ :key :value |
		value = callbackUrlString ifTrue: [
			postFields removeKey: key ] ].
	
	newRequest setPostFields: postFields.
	newRequestContext := PRAdminRequestContext 
		request: newRequest
		response: WABufferedResponse new
		codec: requestContext codec.
		
	newRequestContext handlers
		add: requestContext session;
		add: requestContext application.
		
	^ newRequestContext! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 2/13/2012 23:11'!
houseKeepingOn: html
	self ensureThatKeysOnMainPageAndPreviewIFrameDontClashOn: html.
	self renderKeepSessionAliveTimerOn: html! !

!PRAdminUI methodsFor: 'testing' stamp: 'NickAger 2/14/2012 00:02'!
isShowingPreview
	^ self pierComponent isShowingPreview! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 2/14/2012 00:02'!
kernel
	^ self pierComponent kernel! !

!PRAdminUI methodsFor: 'private' stamp: 'NickAger 3/7/2012 08:56'!
logout
	self context: (self context user: nil).
	self context: (self context structure: self context root).
	self session presenter home ! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 11/17/2011 13:53'!
navigatorComponent
	^ navigatorComponent ifNil: [ navigatorComponent := PRAdminNavigator contextGetCallback: [ self context ] contextSetCallback: [ :newContext | self context: newContext ] ]! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 2/14/2012 07:47'!
onlyRenderPierComponent
	"After the initial rendering, content is rendered via ajax updates.
	 When we re-render the view we only want to render the main content 
	not the complete admin UI.... so the #show: below ensures that 
	subsequent renderings never get here; only the main content 
	(pierFrame) is rendered - that is the Admin UI is never re-rendered
	directly"
	self home; show: self pierComponent.! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 2/14/2012 00:03'!
pierComponent
	^ pierComponent! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 2/14/2012 00:03'!
pierComponent: thePierComponent
	pierComponent := thePierComponent! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 11/19/2011 13:21'!
renderAdminInterfaceOn: html
	html div
		class: 'ui-layout-west';
		id: #sidebars;
		with: [ self renderSidebarOn: html ].
	
	html div
		class: 'pane ui-layout-center';
		id: 'center';
		with: [ 
			self renderMainPaneOn: html ].
		
	self renderLayoutOn: html! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 3/5/2012 15:00'!
renderAssociatedPierInstanceLinkOn: html
	| urlPath kernelApplicationPaths kernelPathPair |
	kernelApplicationPaths := PRAdminKernelPathPair kernelPathPairs.
	kernelPathPair := kernelApplicationPaths detect: [ :each | each kernel = self kernel ] ifNone: [ nil ].

	kernelPathPair notNil ifTrue: [		
		html div
			id: #pierInstanceLink;
			with: [
				| url |
				url := WAUrl absolute: kernelPathPair path.
				html text: 'Associated instance: '.
				html anchor
					class: 'external';
					url: url;
					with: url greaseString ] ]! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 11/25/2011 14:51'!
renderContentOn: html
	self houseKeepingOn: html.
		
	self renderAdminInterfaceOn: html! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 2/14/2012 00:02'!
renderHeadScriptsAndStylesOn: script
	| anHtmlRoot |
	"if we're displaying preview the iframe contains a complete document including head scripts and styles"
	self isShowingPreview ifTrue: [ ^ self ].
	
	anHtmlRoot := PRAdminHtmlRoot context:  script renderContext.
	
	(WAVisiblePresenterGuide client:
		(WAUpdateRootVisitor root: anHtmlRoot))
		start: self pierComponent.
		
	self addHeadScriptsAndStyles: anHtmlRoot on: script! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 3/7/2012 08:55'!
renderHeaderOn: html
	html div
		id: #header;	
		class: 'title';	
		with: [ 
			html anchor
				url: self application url;
				with: [
					html heading: 'Pier Admin' ].
			
			html div
				id: #loggedInAs;
				with: [	
					html text: 'Logged in as '.
					html emphasis: self context user fullName.
					html space.
					html anchor
						callback: [ self logout ];
						with: 'logout' ] ]! !

!PRAdminUI methodsFor: 'renderering hijax' stamp: 'NickAger 3/7/2012 08:48'!
renderIFrameViewOn: html
	| callbackUrl jqPost requestType |
	"valueholder for Gemstone 2.4.* compatibility see:
	- http://code.google.com/p/glassdb/issues/detail?id=221
	- http://forum.world.st/use-of-method-temporaries-in-callback-blocks-td2340788.html"
	callbackUrl := WAValueHolder new. 
	requestType := WAValueHolder new.
	
	html script: self addIFrameScriptIfNotAlreadyInstalledJS.
	html script: self addIFrameStyleIfNotAlreadyInstalledJS.

	jqPost := html jQuery post
		callback: [ :value | 
			| parameters |
			parameters := value subStrings:  ','.
			self assert: parameters size = 2.
			callbackUrl contents: (WAUrl absolute: parameters first).
			requestType contents: parameters second ] 
		value: (JSStream on: '[url, (data==null) ? "GET" : "POST"]');
		addParameter: (JSStream on: 'data').
		
	jqPost script: [ :s | 
		self renderIFrameViewResponseForUrl: callbackUrl contents requestType: requestType contents callbackId: jqPost callbackId on: s.
		self announceAjaxUpdateWithoutSelfOn: s ].
		
	html script: ((jqPost asFunction: #('url' 'data')) assignLocalTo: 'handleIFrameViewClick').
	
	html iframe
		id: #iFrameView;
		callback: [ self session presenter show: 
			(self pierComponent addDecoration: PRAdminIFrameDecorator new; yourself) ].

	self flag: #todo. "replace with jQueryInstance>>#delegate:on:do: with:  jQueryInstance>>#on:selector:do: or  jQueryInstance>>#on:do: - defined in later versions of Seaside "
	html document addLoadScript: 
		((html jQuery: #iFrameView) onLoad:
			(((html jQuery this contents find: 'body')
				delegate: 'a'
				on: 'click'
				do: 
			'if (this.getAttribute("href")) {
				var urlParts = this.getAttribute("href").split("?");
				if (urlParts.length > 1 && (urlParts[1].substr(0, 2) == "_s" ||  urlParts[1].substr(0, 2) == "_k")) {
					handleIFrameViewClick(this.getAttribute("href"), null); return false;
				}
			}
			return true;'),
			((html jQuery this contents find: 'body')
				delegate: 'input[type=submit], button[type=submit]'
				on: 'click'
				do: 'var form = $(this).closest("form"); 
					if(form.length == 1) {
						handleIFrameViewClick(form.attr("action"), form.find(":input").serialize() + "&" + $(this).attr("name")); 
						return false
					}')))! !

!PRAdminUI methodsFor: 'renderering hijax' stamp: 'NickAger 12/5/2011 10:55'!
renderIFrameViewResponseForUrl: callbackUrl requestType: requestType callbackId: callbackId on: script
	| requestContext document |

	requestContext := self renderResponseForUrl: callbackUrl requestType: requestType callbackId: callbackId.
	document := requestContext document.
	
	document isNil 
		ifTrue: [ 
			"some views generate a response directly eg wikiview"
			script <<  
				((script jQuery: #iFrameView) contents find: 'body') html: [ :r |
					self renderNonDocumentResponse: requestContext response on: r ] ]
		ifFalse: [
			"the  rendering artifacts (head, body, scripts) have been separated"	
			self addIFrameHeadScriptsAndStyles: document htmlRoot on: script.
	
			script <<  ((script jQuery: #iFrameView) contents find: 'body') html: [ :r |
				r html: document bodyHtml ].
	
			document bodyScripts do: [ :each |
				script << (JSStream on: ('evalScriptWithinIFrame(', each asJavascript, ')')) ].	
	
			 document loadScripts do: [ :each |
				script << (JSStream on: ('evalScriptWithinIFrame(', each asJavascript asJavascript, ')')) ] ]! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 9/23/2011 22:11'!
renderKeepSessionAliveTimerOn: html
	| timeOutPeriodInSeconds |
	timeOutPeriodInSeconds := self application cache expiryPolicy configuration at: #cacheTimeout.
	 html document addLoadScript: (html jQuery ajax
               callback: [ "Do nothing" ];
               interval: (Duration seconds: timeOutPeriodInSeconds / 2)).! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 11/17/2011 14:46'!
renderLayoutOn: html
 	| myLayout |
	myLayout := (html jQuery: 'body') layout.
	myLayout west
		at: 'size' put: 200; 
		"at: 'maxSize' put: 280;"
		at: 'onresize' put: ((html jQuery: #sidebars) accordion resize) asFunction ; 
		at: 'togglerLength_open' put: 20; 
		at: 'togglerLength_closed' put: 20; 
		at: 'togglerAlign_open' put: 'top'; 
		at: 'togglerAlign_closed' put: 'top'; 
		at: 'togglerContent_closed' put: '&#8250';
		at: 'togglerContent_open' put: '&#8249'.
	myLayout east
		at: 'initClosed' put: true.
	html document addLoadScript: myLayout.
	! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 11/18/2011 19:08'!
renderMainPaneOn: html
	html div
		id: #main;
		with: [
			html render: self tabsComponent.
			
			html script: self addScriptIfNotAlreadyInstalledJS.
			html script: self addStyleIfNotAlreadyInstalledJS.
			self renderViewContentOn: html ]! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 3/7/2012 08:47'!
renderNonDocumentResponse: response on: html
	response contentType seasideMimeType = WAMimeType textHtml
		ifTrue: [ html html: response contents ]
		ifFalse: [ html text: response contents ]! !

!PRAdminUI methodsFor: 'renderering hijax' stamp: 'NickAger 3/7/2012 08:49'!
renderResponseForUrl: callbackUrl  requestType: requestType callbackId: callbackId
	| newRequestContext |
	
	newRequestContext := self generateRequestContextFor: callbackUrl requestType: requestType callbackId: callbackId.
	[ self session handle: newRequestContext ] 
		on: WAResponseNotification
		do: [ :n | "we've rendered a response, drop through" ].

	^ newRequestContext! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 11/24/2011 10:38'!
renderSidebarOn: html
	html div
		id: #sidebar;
		with: [ 
			self renderHeaderOn: html.
			html render: self navigatorComponent.
			html render: self commandsComponent.
			self renderAssociatedPierInstanceLinkOn: html ]! !

!PRAdminUI methodsFor: 'rendering' stamp: 'NickAger 2/14/2012 10:34'!
renderViewContentOn: html
	html div
		id: #content;
			with: [
				self isShowingPreview
					ifTrue: [
						self renderIFrameViewOn: html ]
					ifFalse: [
						self onlyRenderPierComponent.
						self renderViewOn: html ]  ]! !

!PRAdminUI methodsFor: 'renderering hijax' stamp: 'NickAger 3/7/2012 08:48'!
renderViewOn: html
	| callbackUrl jqPost requestType |
	"valueholder for Gemstone 2.4.* compatibility see:
	- http://code.google.com/p/glassdb/issues/detail?id=221
	- http://forum.world.st/use-of-method-temporaries-in-callback-blocks-td2340788.html"
	callbackUrl := WAValueHolder new. 
	requestType := WAValueHolder new.
	
	jqPost := html jQuery post
		callback: [ :value |
			| parameters |
			parameters := value subStrings: ','.
			self assert: parameters size = 2.
			callbackUrl contents: (WAUrl absolute: parameters first).
			requestType contents: parameters second ] 
			value: (JSStream on: '[url, (data==null) ? "GET" : "POST"]');
		addParameter: (JSStream on: 'data').
		
	jqPost script: [ :s | 
		self renderViewResponseForUrl: callbackUrl contents requestType: requestType contents callbackId: jqPost callbackId on: s.
		self announceAjaxUpdateWithoutSelfOn: s ].
	
	html script: ((jqPost asFunction: #('url' 'data')) assignLocalTo: 'handleViewClick').

	html render: self pierComponent.
	
	self flag: #todo. "replace with jQueryInstance>>#delegate:on:do: with:  jQueryInstance>>#on:selector:do: or  jQueryInstance>>#on:do: - defined in later versions of Seaside "
	html document addLoadScript: 
		((html jQuery: #content)
			delegate: 'a'
			on: 'click'
			do: '
			if (this.getAttribute("href")) {
				var urlParts = this.getAttribute("href").split("?");
				if (urlParts.length > 1 && (urlParts[1].substr(0, 2) == "_s" ||  urlParts[1].substr(0, 2) == "_k")) {
					handleViewClick(this.getAttribute("href"), null); return false;
				}
			}
			return true;';
			delegate: 'input[type=submit], button[type=submit]'
			on: 'click'
			do: 'var form = $(this).closest("form"); 
				if(form.length == 1) {
					handleViewClick(form.attr("action"), form.find(":input").serialize() + "&" + $(this).attr("name")); 
					return false
				}')

! !

!PRAdminUI methodsFor: 'renderering hijax' stamp: 'NickAger 12/5/2011 10:55'!
renderViewResponseForUrl: callbackUrl requestType: requestType callbackId: callbackId on: script
	| requestContext document |

	requestContext := self renderResponseForUrl: callbackUrl requestType: requestType  callbackId: callbackId.
	document := requestContext document.
	
	document isNil 
		ifTrue: [
			"some views generate a response directly eg wikiview"
			script <<  
				 (script jQuery: #content) html: [ :r | 
					self renderNonDocumentResponse: requestContext response on: r ] ]
		ifFalse: [
			"the  rendering artifacts (head, body, scripts) have been separated"
			self addHeadScriptsAndStyles: document htmlRoot on: script.

			script << (script jQuery: #content) html: [ :r | r html: document bodyHtml ].
	
			document bodyScripts do: [ :each |
				script << (JSStream on: each) ].	
	
			document loadScripts do: [ :each |
				script << (JSStream on: each asJavascript) ] ]
! !

!PRAdminUI methodsFor: 'hooks' stamp: 'NickAger 2/14/2012 00:02'!
states
	^ Array with: self pierComponent! !

!PRAdminUI methodsFor: 'accessing' stamp: 'NickAger 11/17/2011 13:56'!
tabsComponent
	^ tabsComponent ifNil: [ tabsComponent := PRAdminTabs contextGetCallback: [ self context ] contextSetCallback: [ :newContext | self context: newContext ] ]! !

!PRAdminUI methodsFor: 'updating' stamp: 'NickAger 11/25/2011 16:42'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.

	JSTreeFileLibrary default updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #jquerylayoutminJs.
	
	anHtmlRoot stylesheet url: PRAdminFileLibrary / #pieradminCss.


	
! !

PRAdminAnnouncingComponent subclass: #PRAdminUIChild
	instanceVariableNames: 'contextGetCallback contextSetCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminUIChild commentStamp: 'NickAger 2/13/2012 17:08' prior: 0!
I provide a base for the admin ui components, allowing context sharing between components.!

PRAdminUIChild subclass: #PRAdminCommands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminCommands commentStamp: 'NickAger 2/13/2012 17:05' prior: 0!
I provide access to global commands which are not accessible via right-click on the navigator. The commands available can be edited in ==/config/pieradmin==, by default the global commands are defined by:
+value:source|class=PRAdminConfigurator|selector=filteredCommandClasses+

!

!PRAdminCommands methodsFor: 'announcing' stamp: 'NickAger 11/17/2011 13:35'!
announcementRegister
	"empty as I dont dynamically update myself"! !

!PRAdminCommands methodsFor: 'rendering' stamp: 'NickAger 3/7/2012 08:47'!
renderContentOn: html
	html div
		id: #commands;
		with: [ 
			html form: [
				| selectId |
				html label
         				for: (selectId := html nextId);
         				with: [
						html div: 'Global commands: ' ].
			
				html select
					id: selectId;
					list: self application pierAdminCommands;
					labels: [ :class | class label ];
					selected: PRSettingsCommand;
					callback: [ :class | 
						self context: (self context command: class new) ].
					
				html button
					bePush
					onClick: (html jQuery ajax serialize: (html jQuery id: selectId); script: [ :s | self announceAjaxUpdate: s ]);
					with: 'Do' ] ] ! !

PRAdminUIChild subclass: #PRAdminNavigator
	instanceVariableNames: 'displayedStructure dontUpdateOnSelect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminNavigator commentStamp: 'NickAger 2/13/2012 16:33' prior: 0!
I render the navigator on the left-hand-side of the Admin UI. I also provide a context sensitive right-click menu when a node is selected and respond to requests on the menu. !

!PRAdminNavigator methodsFor: 'commands' stamp: 'NickAger 12/6/2011 13:37'!
addableChildStructureClassesFor: aContext
	| addableChildStructureClasses |
	addableChildStructureClasses := PRStructure withAllConcreteClasses select: [ :each |
		(aContext structure class canBeParentOf: each)
			and: [ each canBeChildOf: aContext structure class ] ].
	
	addableChildStructureClasses := addableChildStructureClasses select: [ :class |
		aContext structure securityDecoration
			hasPermission: (PUAddPermission
				on: PRAddCommand structure: class)
			for: aContext user ].
	
	"reject PRFile as file uploads dont work in the admin interface as ajax doesnt support
	multipart file uploads. Instead the WYSIWYG editor allows file uploads via hidden iframe"	
	^ addableChildStructureClasses reject: [ :each | each name = PRFile name ]! !

!PRAdminNavigator methodsFor: 'announcing' stamp: 'NickAger 11/25/2011 10:12'!
announcementRegister
	self session pierAdminAnnouncer on: PRAdminAjaxUpdate do: [ :ajaxUpdate |
		self displayedStructure ~= self context structure ifTrue: [
			self setNavigatorSelectionToCurrentStructureOn: ajaxUpdate script.
			self displayedStructure: self context structure ] ]! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/23/2011 14:02'!
contextMenuAddSubmenuFor: structure populate: menuCollection
	| menuItem |
	menuItem := JSTreeContextMenuItem label: 'Add'.
	(self addableChildStructureClassesFor: (self context structure: structure)) do: [ :each |
		| childMenuItem |
		childMenuItem := JSTreeContextMenuItem label:  each label.
		childMenuItem action: [ :s |
			| addCommand |
			"pier part; create the structure"
			addCommand := PRAddCommand new
				setContext: (self context structure: structure);
				type: each;
				doExecute;
				yourself.
			self context: addCommand successAnswer.
			
			"javascript part; create a new node in the tree"
			s << (s jQuery: #navigator) tree 
				createNode: (s jQuery id: (self convertStructureToId: structure)) 
				position: 'last' 
				node: (self createNodeFor: addCommand successAnswer structure)
				jsCreationCallback: nil 
				skipRename: true.
			self dontUpdateOnSelect: true.
			self announceAjaxUpdate: s ].
		menuItem submenu addMenuItem: childMenuItem ].
	menuCollection addMenuItem: menuItem.! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/17/2011 14:35'!
contextMenuCallbackFor: structure populate: menuCollection
	self contextMenuItems do: [ :each |
		 self perform: each with: structure with: menuCollection ]! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 12/16/2011 19:19'!
contextMenuCommand: command for: structure populate: menuCollection
	| commandMenu |
	(command isValidIn: self context) ifFalse: [ ^ self ].

	commandMenu := JSTreeContextMenuItem label: command label.
	commandMenu action: [ :s | 
		self context: (self context structure: structure command: command new).
		self announceAjaxUpdateWithoutSelfOn: s ].
	menuCollection addMenuItem: commandMenu.
	
	^ commandMenu
! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/17/2011 14:31'!
contextMenuCopyFor: structure populate: menuCollection
	self contextMenuCommand: PRCopyCommand for: structure populate: menuCollection
! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/17/2011 14:54'!
contextMenuEditFor: structure populate: menuCollection
	| menuItem |

	menuItem := self contextMenuCommand: PREditCommand for: structure populate: menuCollection.
	menuItem separatorAfter: true.
! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 2/14/2012 10:43'!
contextMenuGroupFor: structure populate: menuCollection
	self contextMenuCommand: PUChangeGroup for: structure populate: menuCollection
! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 2/14/2012 10:45'!
contextMenuItems
	^ #(contextMenuEditFor:populate:  contextMenuAddSubmenuFor:populate: contextMenuRenameFor:populate: contextMenuRemoveFor:populate:  contextMenuCopyFor:populate: contextMenuOrderFor:populate: contextMenuSettingsFor:populate: contextMenuOwnerFor:populate: contextMenuGroupFor:populate: contextMenuOtherFor:populate: )! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/19/2011 09:36'!
contextMenuOrderFor: structure populate: menuCollection
	self contextMenuCommand: PROrderCommand for: structure populate: menuCollection
! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 2/14/2012 10:43'!
contextMenuOtherFor: structure populate: menuCollection
	self contextMenuCommand: PUChangeOther for: structure populate: menuCollection
! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 2/14/2012 10:44'!
contextMenuOwnerFor: structure populate: menuCollection
	
	self contextMenuCommand: PUChangeOwner for: structure populate: menuCollection
! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/18/2011 09:55'!
contextMenuRemoveFor: structure populate: menuCollection
	| commandMenu |
	commandMenu := JSTreeContextMenuItem label: PRRemoveCommand label.
	commandMenu action: [ :s | 
		self context: (self context structure: structure command: 
			(PRAdminRemoveCommand 
				idOfTreeNodeToRemove: (self convertStructureToId: structure)
				pierAdminAnnouncer: self session pierAdminAnnouncer)).
		self announceAjaxUpdateWithoutSelfOn: s ].
	menuCollection addMenuItem: commandMenu.! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/17/2011 14:58'!
contextMenuRenameFor: structure populate: menuCollection
	| menuItem |
	
	menuItem := JSTreeContextMenuItem label: 'Rename'.
	"equivalent to: '$(''#navigator'').jstree(''rename'', ''#''+node.attr(''id''))'   - perhaps it would be simpler to use the string directly!!!!"
	menuItem action: (((JQueryInstance new id: #navigator) tree action: 'rename' arguments: (Array with: ((JQueryInstance new alias: '"#" + node') attributeAt: 'id' ))) asFunction: #(node)). 
	menuCollection addMenuItem: menuItem.! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 2/14/2012 10:44'!
contextMenuSettingsFor: structure populate: menuCollection
	| menuItem |

	menuItem := self contextMenuCommand: PRSettingsCommand for: structure populate: menuCollection.
	menuItem separatorAfter: true.
	
! !

!PRAdminNavigator methodsFor: 'private' stamp: 'NickAger 11/17/2011 15:43'!
convertStructureToId: structure
	| path |
	path := structure absolutePath.
	"path slashes '/' arent allowed in html element ids. Convert '/' to '-_', use '-' in front of root to help uniqueness"
	^ String streamContents: [ :stream |
		stream nextPutAll: '-_'.
		(path subStrings: '/') do: [ :pathElement |
			stream nextPutAll: pathElement ]
			separatedBy: [ stream nextPutAll: '-_' ] ]! !

!PRAdminNavigator methodsFor: 'private' stamp: 'NickAger 12/4/2011 17:50'!
createNodeFor: aStructure
	^ JSTreeNode new
		id: (self convertStructureToId: aStructure);
		title: (aStructure isRoot ifTrue: [ '/' ] ifFalse: [ aStructure name ]);
		attributes: (GRSmallDictionary new at: 'title' put:  aStructure title; yourself);
		metadata:
			(GRSmallDictionary new
				at: 'absolutePath' put: aStructure absolutePath;
				yourself);
		"If children isn't defined here, the tree will lazily load as nodes are opened via Ajax. 
		Instead the complete tree is initially defined and sent to the client. Why? It simplifies 
		highlighting arbitary nodes including opening intermediate parent nodes"
		children: (self createNodesFor: aStructure enumerator);
		yourself! !

!PRAdminNavigator methodsFor: 'private' stamp: 'NickAger 11/10/2011 10:40'!
createNodesFor: aStructureCollection
	^ aStructureCollection collect: [ :each | self createNodeFor: each ]! !

!PRAdminNavigator methodsFor: 'accessing' stamp: 'NickAger 11/25/2011 10:12'!
displayedStructure
	^ displayedStructure ifNil: [ displayedStructure := self root ]! !

!PRAdminNavigator methodsFor: 'accessing' stamp: 'NickAger 11/25/2011 10:11'!
displayedStructure: anObject
	^ displayedStructure := anObject! !

!PRAdminNavigator methodsFor: 'accessing' stamp: 'NickAger 11/23/2011 14:00'!
dontUpdateOnSelect
	^ dontUpdateOnSelect ifNil: [ dontUpdateOnSelect := false ]! !

!PRAdminNavigator methodsFor: 'accessing' stamp: 'NickAger 11/23/2011 13:58'!
dontUpdateOnSelect: anObject
	dontUpdateOnSelect := anObject! !

!PRAdminNavigator methodsFor: 'private' stamp: 'NickAger 11/17/2011 15:40'!
initiallyOpen
	^ Array with: (self convertStructureToId: self root)! !

!PRAdminNavigator methodsFor: 'testing' stamp: 'NickAger 11/25/2011 10:47'!
isSameStructureSelected: structure
	^ self context structure = structure! !

!PRAdminNavigator methodsFor: 'rendering' stamp: 'NickAger 11/25/2011 10:47'!
nodeSelectedCallbackFor: structure on: script
	self dontUpdateOnSelect ifTrue: [ 
		self dontUpdateOnSelect: false. 
		^ self ].
	
	(self isSameStructureSelected: structure) ifTrue: [	
		^ self ].
	
	self context: (self context structure: structure). 
	self announceAjaxUpdateWithoutSelfOn: script! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 11/18/2011 18:57'!
renameCallbackNewName: newName structure: structure on: script
	| oldjQueryNodeId newJQueryNodeId |
	newName = structure name ifTrue: [
		^ self ].
	
	(PRPath isValidName: newName) ifFalse: [ 
		script << 
			(JSStream on: 'renameError(''Rename failed. The new name: "', newName, '", contains invalid characters.'')').
		^ self ].
		
	structure parent childrenDecoration at: newName ifPresent: [ :childStructure |
		 script << 
			(JSStream on: 'renameError(''Renamed failed. The new name: "', newName, '", is the same name as an existing element.'')').
		^ self ].
		
	oldjQueryNodeId := self convertStructureToId: structure.
	
	structure name: newName.
	
	newJQueryNodeId := self convertStructureToId: structure.
	
	script << (script jQuery id: oldjQueryNodeId) attributeAt: 'id' put: newJQueryNodeId.
	script << (script jQuery id: newJQueryNodeId) dataAt: 'absolutePath'  put: structure absolutePath! !

!PRAdminNavigator methodsFor: 'rendering' stamp: 'NickAger 11/18/2011 18:52'!
renderContentOn: html
	self renderNavigatorTreeOn: html.
	self renderRefreshButtonOn: html.
	self renderRenameJsSupportOn: html! !

!PRAdminNavigator methodsFor: 'rendering' stamp: 'NickAger 11/17/2011 15:01'!
renderNavigatorTreeOn: html
	html div
		id: #navigator;
		script:
			((html jQuery this tree)
				plugins: #('json_data' 'types' 'themes' 'ui' 'contextmenu' 'crrm');
				childrenBlock: [ :node | 
					| aStructure |
					aStructure := self retrieveStructureFrom: node.
					self createNodesFor: aStructure enumerator ]
				rootNodes: [ self createNodeFor: self root ];
				selectBlock: [ :event :script | 
					self nodeSelectedCallbackFor: (self retrieveStructureFrom: event node) on: script ];
				contextMenuBlock: [ :node :menuCollection |
					self contextMenuCallbackFor: (self retrieveStructureFrom: node) populate: menuCollection ];
				renameBlock: [ :renameEvent :script |
					self renameCallbackNewName: renameEvent title structure: (self retrieveStructureFrom: renameEvent node) on: script ];
				selectLimit: 1;
				initiallyOpen: self initiallyOpen;
				initiallySelected: self initiallyOpen).
	! !

!PRAdminNavigator methodsFor: 'context menu' stamp: 'NickAger 3/7/2012 08:47'!
renderRefreshButtonOn: html
	html form
		id: #refreshNavigator;
		with: [
			html button
				bePush;
				onClick: (html jQuery ajax script: [ :s | s << (s jQuery: #navigator) replaceWith: [ : r | self renderNavigatorTreeOn: r ] ]);
				with: 'Refresh Navigator' ]! !

!PRAdminNavigator methodsFor: 'rendering' stamp: 'NickAger 11/18/2011 18:52'!
renderRenameJsSupportOn: html
	html script:
		((((html javascript alert: (JSStream on: 'message')),
		(JSStream on: '$.jstree.rollbackLast()'))
		asFunction: #(message elementId)) 
		assignLocalTo: 'renameError'). ! !

!PRAdminNavigator methodsFor: 'private' stamp: 'NickAger 3/7/2012 08:47'!
retrieveStructureFrom: aJSTreeNode 
	| absolutePath path |
	absolutePath := aJSTreeNode metadata at: 'absolutePath'.
	path := self root lookupPath: absolutePath ifAbsent: [ self error: 'cannot retrieve structure for path: "', absolutePath,  '"' ].
	^ path! !

!PRAdminNavigator methodsFor: 'private' stamp: 'NickAger 11/10/2011 11:05'!
root
	^ self context root! !

!PRAdminNavigator methodsFor: 'ajax update' stamp: 'NickAger 11/17/2011 17:41'!
setNavigatorSelectionToCurrentStructureOn: s
	"ensure the current structure's node is selected:"
	s << (s jQuery: #navigator) tree select: (s jQuery id: (self convertStructureToId: self context structure)) check: true.
	"unfortunately selecting a node causes a select event - which calls us back. Potentially this could cause an infinate callback-response loop.
	to avoid this the select block ajax update doesnt update the navigator ie avoid calling this method. Also if the selected node in the callback
	is the same contexts structure then no ajax updating is performed"! !

PRAdminUIChild subclass: #PRAdminTabs
	instanceVariableNames: 'lastViewClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminTabs commentStamp: 'NickAger 2/13/2012 16:30' prior: 0!
I render the view tabs along the top of the Admin UI. The views I display are defined in the ==/config/pieradmin==, in the ""Tabbed Views"" entry under the ""Pier Admin"" section. By default the following views are defined:
+value:source|class=PRAdminConfigurator|selector=defaultViews+!

!PRAdminTabs methodsFor: 'announcing' stamp: 'NickAger 11/18/2011 19:06'!
announcementRegister
	self session pierAdminAnnouncer on: PRAdminAjaxUpdate do: [ :ajaxUpdate |
		self selectedContextViewClass ~= lastViewClass ifTrue: [
			| s |
			lastViewClass := self selectedContextViewClass.
			s := ajaxUpdate script.
			s << (s jQuery: #tabs) replaceWith: [ :r | r render: self ] ] ]! !

!PRAdminTabs methodsFor: 'rendering' stamp: 'NickAger 11/9/2011 22:49'!
renderContentOn: html
	html div
		id: #tabs;
		with: [
			html unorderedList
				class: 'tabs';
				with: [
					self application pierAdminViews do: [ :eachView |
						self renderTabForView: eachView on: html ] ] ]! !

!PRAdminTabs methodsFor: 'rendering' stamp: 'NickAger 3/7/2012 08:48'!
renderTabForView: aViewClass on: html
	html listItem
		class: 'tab';
		class: 'active' if: self selectedContextViewClass = aViewClass;
		with: [
			html anchor
				onClick: (html jQuery ajax script: [ :s | 
					self context: (self context view: aViewClass).
					self announceAjaxUpdate: s ]);
				with: [
					html span
						class: 'left';
						with: aViewClass label.
					html span class: 'right' ] ]! !

!PRAdminTabs methodsFor: 'accessing' stamp: 'NickAger 11/10/2011 10:28'!
selectedContextViewClass
	^ self context command isView
		ifTrue: [ self context command viewComponent class ]! !

!PRAdminUIChild class methodsFor: 'instance creation' stamp: 'NickAger 11/10/2011 16:57'!
contextGetCallback: contextGetCallback contextSetCallback: contextSetCallback
	^ self new
		contextGetCallback: contextGetCallback; 
		contextSetCallback: contextSetCallback;
		yourself
		! !

!PRAdminUIChild methodsFor: 'accessing' stamp: 'NickAger 11/10/2011 16:54'!
context
	^ contextGetCallback value
! !

!PRAdminUIChild methodsFor: 'accessing' stamp: 'NickAger 11/10/2011 16:55'!
context: anObject
	contextSetCallback value: anObject
! !

!PRAdminUIChild methodsFor: 'accessing' stamp: 'NickAger 11/10/2011 16:56'!
contextGetCallback: anObject
	contextGetCallback := anObject! !

!PRAdminUIChild methodsFor: 'accessing' stamp: 'NickAger 11/10/2011 16:56'!
contextSetCallback: anObject
	contextSetCallback := anObject! !

WAComponent subclass: #PRAdminLogin
	instanceVariableNames: 'pierComponent loginComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminLogin commentStamp: 'NickAger 3/7/2012 08:36' prior: 0!
I am the root class of Pier Admin. I login the user, set that user into the kernel's context then #show: ==PRAdminUI== - the Pier administrative UI!!
!

!PRAdminLogin class methodsFor: 'initialize' stamp: 'NickAger 3/5/2012 14:53'!
registerAt: dispatcherName administering: kernelPathPair
	| pierAdminApplication |
	pierAdminApplication := (WAAdmin register: self asApplicationAt: dispatcherName)
		preferenceAt: #useCookies put: false;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		preferenceAt: #documentClass put: PRAdminHtmlDocumentStoredHeadElements;
		preferenceAt: #actionPhaseContinuationClass put: PRAdminActionPhaseContinuation;
		preferenceAt: #renderPhaseContinuationClass put: PRAdminRenderPhaseContinuation;
		preferenceAt: #rootDecorationClasses put: #();
		yourself.
	
	pierAdminApplication
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQBaseTheme;
		addLibrary: SPHighlightedStyle.

	pierAdminApplication configuration addParent: NAFileUploadConfigurator instance.	
	pierAdminApplication configuration addParent: PRAdminConfigurator instance.
	pierAdminApplication pierAdminKernelPathPair: kernelPathPair! !

!PRAdminLogin class methodsFor: 'initialize' stamp: 'NickAger 3/5/2012 15:13'!
registerForAdministering: kernelPathPair
	| adminInstancePath |
	
	adminInstancePath := kernelPathPair path, '-admin'.
	self registerAt: adminInstancePath administering: kernelPathPair.
	^ adminInstancePath! !

!PRAdminLogin methodsFor: 'accessing' stamp: 'NickAger 2/28/2012 18:26'!
children
	^ Array with: self pierComponent with: self loginComponent! !

!PRAdminLogin methodsFor: 'private' stamp: 'NickAger 3/7/2012 08:58'!
handleLoginAnswer: loginCommand
	loginCommand isNil
		ifTrue: [ ^ self ].
	loginCommand successAnswer: loginCommand.
	[ 
	loginCommand doValidate.
	loginCommand doAnswer ]
		on: MAError
		do: [ :error | self loginComponent errors add: error ].
	self loginComponent errors isEmpty
		ifFalse: [ ^ self ].
	self pierComponent setLoggedInUser: loginCommand user.
	self show: (PRAdminUI pierComponent: self pierComponent)! !

!PRAdminLogin methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 14:53'!
kernelPathPair
	^ self application pierAdminKernelPathPair! !

!PRAdminLogin methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 16:22'!
loginComponent
	^ loginComponent ifNil: [ 
		| loginCommand |
		loginCommand := PULogin new 
			setContext: (self pierComponent context);
			yourself.
			
		loginComponent := loginCommand asComponent
		 	onAnswer: [ :aLoginCommand | self handleLoginAnswer: aLoginCommand ];
			yourself ]! !

!PRAdminLogin methodsFor: 'accessing' stamp: 'NickAger 3/3/2012 09:19'!
pierComponent
	^ pierComponent ifNil: [
		pierComponent := PRAdminPierComponent kernel: self kernelPathPair kernel ]! !

!PRAdminLogin methodsFor: 'rendering' stamp: 'NickAger 3/5/2012 16:35'!
renderContentOn: html
	html div
		class: 'adminLogin';
		with: [
			self renderTitleOn: html.
			self renderInfoOn: html.

			html render: self loginComponent ]! !

!PRAdminLogin methodsFor: 'rendering' stamp: 'NickAger 3/5/2012 16:22'!
renderInfoOn: html
	html heading
		level3;
		with: 'Login to: ', self kernelPathPair greaseString.! !

!PRAdminLogin methodsFor: 'rendering' stamp: 'NickAger 3/5/2012 16:26'!
renderTitleOn: html
	html heading
		level1;
		class: 'adminLoginTitle';
		with: [
			html text: 'Welcome to '.
			html image url:  PRAdminFileLibrary / #pierlogo75x35Png.
			html text: ' admin' ]! !

!PRAdminLogin methodsFor: 'hooks' stamp: 'NickAger 2/28/2012 18:24'!
states
	^ Array with: self ! !

!PRAdminLogin methodsFor: 'updating' stamp: 'NickAger 3/5/2012 16:36'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	PRAdminFileLibrary default updateRoot: anHtmlRoot! !

WAComponent subclass: #PRAdminSetup
	instanceVariableNames: 'connectExistingKernelComponent createKernelFromTemplateComponent recreateExportedKernelComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-Core'!

!PRAdminSetup commentStamp: 'NickAger 3/7/2012 08:35' prior: 0!
I am the root class of Pier Admin Setup. I help generate Pier and Pier admin instances, giving the user the choice to:
# Generate a Pier Admin instance from a existing Pier instance
# Generate a Pier instance (and optional Pier Admin instance) from a Pier kernel template.
# Generate a Pier instance (and optional Pier Admin instance) from a Pier kernel exported using ==Pier-Exporter-Code==.!!!

!PRAdminSetup class methodsFor: 'initialization' stamp: 'NickAger 3/6/2012 15:29'!
initialize
	| piersetup |
	piersetup := (WAAdmin register: self asApplicationAt: 'piersetup')
		preferenceAt: #useCookies put: false;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		preferenceAt: #rootDecorationClasses put: #();
		yourself.
	
	piersetup
		addLibrary: JQDeploymentLibrary! !

!PRAdminSetup class methodsFor: 'private' stamp: 'NickAger 3/5/2012 14:29'!
recursiveDispatcherHandersDo: aBlock
	self recursiveHandersOn: WADispatcher default path: '' do: aBlock ! !

!PRAdminSetup class methodsFor: 'private' stamp: 'NickAger 3/5/2012 14:26'!
recursiveHandersOn: aDispatcher path: path do: aBlock
	aDispatcher handlers associationsDo: [ :each | 
		| handlerPath |
		handlerPath := path, '/', each key.
		aBlock value: each value value: handlerPath.
		
		each value isDispatcher ifTrue: [ 
			self recursiveHandersOn: each value path: handlerPath do: aBlock ] ]! !

!PRAdminSetup methodsFor: 'hooks' stamp: 'NickAger 3/1/2012 13:10'!
children
	^ Array with: self connectExistingKernelComponent with: self createKernelFromTemplateComponent with: self recreateExportedKernelComponent! !

!PRAdminSetup methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 15:17'!
connectExistingKernelComponent
	^ connectExistingKernelComponent ifNil: [ connectExistingKernelComponent := PRAdminSetupExistingKernel new ]! !

!PRAdminSetup methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 15:17'!
createKernelFromTemplateComponent
	^ createKernelFromTemplateComponent ifNil: [ createKernelFromTemplateComponent := PRAdminSetupCreateKernelFromTemplate new ]! !

!PRAdminSetup methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 15:18'!
recreateExportedKernelComponent
	^ recreateExportedKernelComponent ifNil: [ recreateExportedKernelComponent := PRAdminSetupRecreateExportedKernel new ] ! !

!PRAdminSetup methodsFor: 'rendering' stamp: 'NickAger 3/6/2012 15:50'!
renderContentOn: html
	self renderTitleOn: html.
	self renderTitleStrapLineOn: html.
	
	html render: self connectExistingKernelComponent.
	html render: self createKernelFromTemplateComponent.
	html render: self recreateExportedKernelComponent! !

!PRAdminSetup methodsFor: 'rendering' stamp: 'NickAger 3/5/2012 14:15'!
renderTitleOn: html
	html heading
		level1;
		class: 'setupAdminPierTitle';
		with: [
			html text: 'Welcome to '.
			html image url:  PRAdminFileLibrary / #pierlogo75x35Png.
			html text: ' admin setup' ]! !

!PRAdminSetup methodsFor: 'rendering' stamp: 'NickAger 3/6/2012 16:02'!
renderTitleStrapLineOn: html
	html div
		class: 'setupAdminStrapline';
		with: [
			html paragraph: 'Pier admin setup will create an admin instance associated with a Pier kernel.'.
			html paragraph: ' Choose from:'.
			html paragraph: [
				html span class: 'setupAdminStraplineHighlight'; with: 'Either: 1) '.
				html text: 'Create an admin instance for an existing kernel, '.
				html span class: 'setupAdminStraplineHighlight'; with: '2) '.
				html text: 'create a new kernel from a template distribution or'.
				html span class: 'setupAdminStraplineHighlight'; with: ' 3) '.
				html text: 'recreate an exported kernel.' ] ]! !

!PRAdminSetup methodsFor: 'updating' stamp: 'NickAger 3/7/2012 08:55'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	PRAdminSetupFileLibrary default updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Pier Admin Setup'! !

WAComponent subclass: #PRAdminSetupOverlaySupportBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-Core'!

PRAdminSetupOverlaySupportBase subclass: #PRAdminSetupChooseDistribution
	instanceVariableNames: 'selectedDistribution distributions selectDistributionComponent kernelName applicationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-NewKernelFromDistribution'!

!PRAdminSetupChooseDistribution methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 16:38'!
applicationPath
	^ applicationPath ifNil: [ applicationPath :=  self suggestApplicationPathFrom: self kernelName ]! !

!PRAdminSetupChooseDistribution methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 11:58'!
applicationPath: anObject
	applicationPath := anObject! !

!PRAdminSetupChooseDistribution methodsFor: 'magritte descriptions' stamp: 'NickAger 3/6/2012 13:18'!
applicationPathDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #applicationPath;
		label: 'Application path';
		priority: 300;
		beRequired;
		yourself! !

!PRAdminSetupChooseDistribution methodsFor: 'hooks' stamp: 'NickAger 3/6/2012 11:59'!
children
	^ Array with: self selectDistributionComponent! !

!PRAdminSetupChooseDistribution methodsFor: 'private' stamp: 'NickAger 3/6/2012 13:16'!
distributions
	^ distributions ifNil: [
		 distributions := (OrderedCollection withAll: PRKernelDistributionBase subclasses) sort: [ : a :b  | a name < b name ] ]! !

!PRAdminSetupChooseDistribution methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 16:37'!
kernelName
	^ kernelName ifNil: [ kernelName :=  self suggestKernelNameFrom: self selectedDistribution ]! !

!PRAdminSetupChooseDistribution methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 11:58'!
kernelName: anObject
	kernelName := anObject! !

!PRAdminSetupChooseDistribution methodsFor: 'magritte descriptions' stamp: 'NickAger 3/6/2012 13:18'!
kernelNameDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #kernelName;
		label: 'Kernel name';
		priority: 200;
		beRequired;
		yourself! !

!PRAdminSetupChooseDistribution methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 13:15'!
pierKernelNames
	^ PRAdminKernelPathPair kernelPathPairs collect: [ :each | each kernel name ]! !

!PRAdminSetupChooseDistribution methodsFor: 'rendering' stamp: 'NickAger 3/7/2012 08:52'!
renderAjaxSelectUpdateOn: html
	"when the selected distribution changes the suggested kernel name and suggested application path are updated dynamically"
	
	self flag: #todo. "replace with jQueryInstance>>#delegate:on:do: with:  jQueryInstance>>#on:selector:do: or  jQueryInstance>>#on:do: - defined in later versions of Seaside "
	html document addLoadScript: 
		((html jQuery: #selectDistributionFormContainer) delegate: 'select' on: 'change' do: (html jQuery ajax script: [ :s |
			| memento theSelectedDistribution theKernelName |
			memento := self selectDistributionComponent memento.
			theSelectedDistribution := memento readUsing: self selectedDistributionDescription.
			theKernelName := self suggestKernelNameFrom: theSelectedDistribution.
			memento write: theKernelName using: self kernelNameDescription.
			memento write: (self suggestApplicationPathFrom: theKernelName) using: self applicationPathDescription. 

			 s << (s jQuery: #selectDistributionFormContainer) html: self selectDistributionComponent ]; serializeForm ) )! !

!PRAdminSetupChooseDistribution methodsFor: 'rendering' stamp: 'NickAger 3/6/2012 16:24'!
renderContentOn: html
	html div
		id: #setupAdminKernelFromTemplate;
		with: [
			html heading
				level2;
				with: '2) Create a new kernel from template distribution'.
			
			html div
				id: #selectDistributionFormContainer;
				with: self selectDistributionComponent.
				
			self renderAjaxSelectUpdateOn: html.
			
			self distributions isEmpty ifTrue: [
				self renderOverlayWithMessage: 'No templates found' containerId: #setupAdminKernelFromTemplate on: html ] ]
	
	! !

!PRAdminSetupChooseDistribution methodsFor: 'magritte component' stamp: 'NickAger 3/6/2012 14:03'!
selectDistributionComponent
	^ selectDistributionComponent ifNil: [ 
		selectDistributionComponent := self asComponent
			addValidatedForm: (Array with: #save -> 'Select distribution');
			onAnswer: [ :model | self answer: model ];
			yourself ]
		! !

!PRAdminSetupChooseDistribution methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 11:58'!
selectedDistribution
	^ selectedDistribution ifNil: [ self distributions first ]! !

!PRAdminSetupChooseDistribution methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 11:58'!
selectedDistribution: anObject
	selectedDistribution := anObject! !

!PRAdminSetupChooseDistribution methodsFor: 'magritte descriptions' stamp: 'NickAger 3/6/2012 11:58'!
selectedDistributionDescription
	<magritteDescription>
	^ MASingleOptionDescription new
		options: self distributions;
		accessor: #selectedDistribution;
		label: 'Select distribution';
		priority: 100;
		beRequired;
		yourself! !

!PRAdminSetupChooseDistribution methodsFor: 'private' stamp: 'NickAger 3/6/2012 16:37'!
suggestApplicationPathFrom:  aKernelName
	| suggestedPath |

	suggestedPath := aKernelName collect: [ : char | 
		Character space = char 
			ifTrue: [ $- ]
			ifFalse: [ char asLowercase ] ].
		
	^ suggestedPath select: [ :char | 
		PRPath isValidCharacter: char ]! !

!PRAdminSetupChooseDistribution methodsFor: 'private' stamp: 'NickAger 3/6/2012 16:37'!
suggestKernelNameFrom: distribution
	| pierKernelNames suggestedName |
	
	suggestedName := distribution greaseString.
	pierKernelNames := self pierKernelNames.
	pierKernelNames isEmpty ifTrue: [ ^ suggestedName ].

	[ pierKernelNames includes: suggestedName ] whileTrue: [	
	 suggestedName := suggestedName last isDigit
		ifTrue: [
			| digitSuffix |
			digitSuffix := (suggestedName last digitValue + 1) greaseString.
			suggestedName allButLast,  digitSuffix ]
		ifFalse: [
			suggestedName,  '1' ] ].
		
	^ suggestedName ! !

PRAdminSetupOverlaySupportBase subclass: #PRAdminSetupChooseExistingKernel
	instanceVariableNames: 'selectKernelComponent selectedKernelPathPair kernelPathsPairs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-ExistingKernel'!

!PRAdminSetupChooseExistingKernel methodsFor: 'hooks' stamp: 'NickAger 3/5/2012 13:36'!
children
	^ Array with: self selectKernelComponent! !

!PRAdminSetupChooseExistingKernel methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 15:47'!
kernelPathsPairs
	^ kernelPathsPairs ifNil: [ 
		kernelPathsPairs := PRAdminKernelPathPair kernelPathPairs select: [ :each |
			| possibleAdminPath |
			possibleAdminPath := each path, '-admin'.
			(WADispatcher default handlerAt: possibleAdminPath ifAbsent: [ nil ]) isNil ] ]
		! !

!PRAdminSetupChooseExistingKernel methodsFor: 'rendering' stamp: 'NickAger 3/6/2012 15:57'!
renderContentOn: html
	html div
		id: #setupAdminExistingKernel; 
		with: [
			html heading
				level2;
				with: '1) Create an admin instance for an existing kernel'.

			html render: self selectKernelComponent.

			self kernelPathsPairs isEmpty ifTrue: [
				self renderOverlayWithMessage: 'No unmanaged kernels found' containerId: #setupAdminExistingKernel on: html ] ]! !

!PRAdminSetupChooseExistingKernel methodsFor: 'magritte component' stamp: 'NickAger 3/5/2012 13:39'!
selectKernelComponent
	^ selectKernelComponent ifNil: [ 
		selectKernelComponent := self asComponent
			addValidatedForm: (Array with: #save -> 'Select Existing Kernel');
			onAnswer: [ :model | self answer: self selectedKernelPathPair ];
			yourself ]
		! !

!PRAdminSetupChooseExistingKernel methodsFor: 'accessing' stamp: 'NickAger 3/7/2012 08:58'!
selectedKernelPathPair
	^ selectedKernelPathPair
		ifNil: [ 
			self kernelPathsPairs isEmpty
				ifFalse: [ selectedKernelPathPair := self kernelPathsPairs first ] ]! !

!PRAdminSetupChooseExistingKernel methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 13:34'!
selectedKernelPathPair: anObject
	^ selectedKernelPathPair := anObject! !

!PRAdminSetupChooseExistingKernel methodsFor: 'magritte descriptions' stamp: 'NickAger 3/5/2012 15:02'!
selectedKernelPathPairDescription
	<magritteDescription>
	^ MASingleOptionDescription new
		options: self kernelPathsPairs;
		accessor: #selectedKernelPathPair;
		label: 'Select kernel';
		beRequired;
		yourself! !

!PRAdminSetupOverlaySupportBase methodsFor: 'rendering' stamp: 'NickAger 3/6/2012 15:52'!
renderOverlayWithMessage: message containerId: containerId on: html
	html div
		id: (containerId, '-overlay');
		class: 'setupAdminOverlayBase';
		script: (html jQuery this clonePosition: (html jQuery id: containerId));
		with: [
			html div
				class: 'setupAdminOverlayMessage';
				with: message ]! !

PRAdminSetupOverlaySupportBase subclass: #PRAdminSetupSelectExportedKernel
	instanceVariableNames: 'selectedKernel selectExportedKernelComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-RecreateExportedKernel'!

!PRAdminSetupSelectExportedKernel methodsFor: 'hooks' stamp: 'NickAger 3/6/2012 10:33'!
children
	^ Array with: self selectExportedKernelComponent ! !

!PRAdminSetupSelectExportedKernel methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 10:32'!
exportedKernels
	^ PRKernelCreatorBase allSubclasses! !

!PRAdminSetupSelectExportedKernel methodsFor: 'magritte descriptions' stamp: 'NickAger 3/6/2012 10:32'!
exportedKernelsDescription
	<magritteDescription>
	^ MASingleOptionDescription new
		componentClass: PRAdminSetupExportedKernelsSelect;
		options: self exportedKernels;
		accessor: #selectedKernel;
		label: 'Exported kernels';
		beRequired;
		yourself! !

!PRAdminSetupSelectExportedKernel methodsFor: 'rendering' stamp: 'NickAger 3/6/2012 15:58'!
renderContentOn: html
	html div
		id: #setupAdminRecreateExportedKernel;
		with: [
			html heading
				level2;
				with: '3) Recreate exported kernel'.
			
			html render: self selectExportedKernelComponent.
			
			self exportedKernels isEmpty ifTrue: [
				self renderOverlayWithMessage: 'No exported kernels found' containerId: #setupAdminRecreateExportedKernel on: html ] ]! !

!PRAdminSetupSelectExportedKernel methodsFor: 'magritte component' stamp: 'NickAger 3/6/2012 10:38'!
selectExportedKernelComponent
	^ selectExportedKernelComponent ifNil: [ 
		selectExportedKernelComponent := self asComponent
			addValidatedForm: (Array with: #save -> 'Recreate kernel');
			onAnswer: [ :model | self answer: model selectedKernel ];
			yourself ]
		! !

!PRAdminSetupSelectExportedKernel methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 10:32'!
selectedKernel
	^ selectedKernel ifNil: [ 
		self exportedKernels isEmpty 
			ifTrue: [ nil ]
			ifFalse: [ selectedKernel := self exportedKernels first ] ]! !

!PRAdminSetupSelectExportedKernel methodsFor: 'accessing' stamp: 'NickAger 3/6/2012 10:32'!
selectedKernel: anObject
	selectedKernel := anObject! !

WARequestContext subclass: #PRAdminRequestContext
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminRequestContext commentStamp: 'NickAger 2/13/2012 15:49' prior: 0!
Used during Ajax rendering cycles to set ==PRAdminHtmlDocumentSeparateBodyHeadElements== as the document type. ==PRAdminRequestContext== also provides access to the rendered document, allowing separate elements stored by ==PRAdminHtmlDocumentSeparateBodyHeadElements== to be extracted after rendering.!

!PRAdminRequestContext methodsFor: 'accessing' stamp: 'NickAger 9/29/2011 20:00'!
document
	^ document! !

!PRAdminRequestContext methodsFor: 'accessing-dynamic' stamp: 'NickAger 11/9/2011 11:59'!
newDocument
	^ document := (PRAdminHtmlDocumentSeparateBodyHeadElements
		on: self response stream codec: self codec)
		scriptGenerator: (self handler configuration at: #scriptGeneratorClass) new;
		yourself! !

!WARequestContext methodsFor: '*pier-admin' stamp: 'NickAger 2/13/2012 15:35'!
headScripts
	^ self properties at: #headScripts ifAbsent: [ #() ]! !

!WARequestContext methodsFor: '*pier-admin' stamp: 'NickAger 11/9/2011 11:43'!
headScripts: headScripts
	self properties at: #headScripts put: headScripts! !

!WARequestContext methodsFor: '*pier-admin' stamp: 'NickAger 2/13/2012 15:35'!
headStyles
	^ self properties at: #headStyles ifAbsent: [ #() ]! !

!WARequestContext methodsFor: '*pier-admin' stamp: 'NickAger 11/9/2011 20:07'!
headStyles: headStyles
	self properties at: #headStyles put: headStyles! !

WARenderPhaseContinuation subclass: #PRAdminRenderPhaseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminRenderPhaseContinuation commentStamp: 'NickAger 11/25/2011 12:01' prior: 0!
Ensures that ==PRAdminHtmlRoot== is used during rendering.!

!PRAdminRenderPhaseContinuation methodsFor: 'private' stamp: 'NickAger 11/9/2011 11:58'!
createHtmlRootWithContext: aRenderContext
	^ PRAdminHtmlRoot context: aRenderContext! !

WAHtmlDocument subclass: #PRAdminHtmlDocumentSeparateBodyHeadElements
	instanceVariableNames: 'bodyHtml currentStream bodyScripts htmlRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminHtmlDocumentSeparateBodyHeadElements commentStamp: 'NickAger 2/13/2012 15:23' prior: 0!
PRAdminHtmlDocumentSeparateBodyHeadElements only directly renders the body during a response. The head elements are stored but not rendered. Scripts within the body are also stored separately. The head elements and body scripts can then be treated separately to ensure that, for example, scripts and styles are only ever loaded once into an ajax updated page.!

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'accessing' stamp: 'NickAger 11/9/2011 12:40'!
bodyHtml
	^ bodyHtml! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'accessing' stamp: 'NickAger 11/9/2011 12:40'!
bodyHtml: anObject
	bodyHtml := anObject! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'accessing' stamp: 'NickAger 11/3/2011 17:12'!
bodyScripts
	^ bodyScripts ifNil: [ bodyScripts := OrderedCollection new ].! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'actions' stamp: 'NickAger 11/9/2011 12:39'!
close
	self bodyHtml: self stream contents
	! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'writing' stamp: 'NickAger 11/3/2011 17:19'!
closeTag: aString
	aString = 'script'
		ifTrue: [
			self bodyScripts add: currentStream contents.
			currentStream := stream ]
		ifFalse: [
			super closeTag: aString	]! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'accessing' stamp: 'NickAger 3/7/2012 08:48'!
htmlRoot
	^ htmlRoot! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'initialization' stamp: 'NickAger 11/3/2011 17:07'!
initializeWithStream: aStream codec: aCodec
	currentStream := aStream.
	super initializeWithStream: aStream codec: aCodec! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'writing' stamp: 'NickAger 11/3/2011 17:19'!
nextPut: aCharacter
	currentStream nextPut: aCharacter! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'writing' stamp: 'NickAger 11/3/2011 17:19'!
nextPutAll: aString
	currentStream nextPutAll: aString! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'actions' stamp: 'NickAger 11/9/2011 12:33'!
open: aRoot
	htmlRoot := aRoot
	
	"
	deliberately don't call:
	
	super open: aRoot 
	
	so that the rendered document stream only contains
	the contents of the rendered body.
	"
		! !

!PRAdminHtmlDocumentSeparateBodyHeadElements methodsFor: 'writing' stamp: 'NickAger 11/9/2011 12:43'!
openTag: aString attributes: anAttributes closed: aBoolean
	"switch the stream if we're opening a script tag, so that we can store script tag contents separately"
	aString = 'script'
		ifTrue: [
			currentStream := WriteStream on: (String new: 100) ]
		ifFalse: [
			super openTag: aString attributes: anAttributes closed: aBoolean ]! !

WAHtmlDocument subclass: #PRAdminHtmlDocumentStoredHeadElements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminHtmlDocumentStoredHeadElements commentStamp: 'NickAger 2/13/2012 15:25' prior: 0!
Stores the head script and styles that are included during a page request in requestContext properties. This allows subsequent ajax updates to ensure that the same script isn't included multiple times. Only used on the initial full-page request.!

!PRAdminHtmlDocumentStoredHeadElements methodsFor: 'actions' stamp: 'NickAger 11/20/2011 14:52'!
open: aRoot
	"store the head script and styles that are included during a page request.
	Important so that subsequent ajax updates don't include the same script multiple times"
	
	"normally aRoot will be a PRAdminHtmlRoot however when a component contains
	an iFrame aRoot can be a WAHtmlRoot in which case we're outside the immediate
	scope of the admin wrapper and don't need to store the headScripts.
	
	Could have added #scripts & #styles on WAHtmlRoot and made them return 
	an empty collection but it seems less confusing to keep the logic within here"
	(aRoot class canUnderstand: #scripts) ifTrue: [
		self requestContext headScripts: aRoot scripts ].
	
	(aRoot class canUnderstand: #styles) ifTrue: [
		self requestContext headStyles: aRoot styles ].

	super open: aRoot.! !

WADecoration subclass: #PRAdminIFrameDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminIFrameDecorator commentStamp: 'NickAger 11/25/2011 11:15' prior: 0!
PRAdminIFrameDecorator retrieves the head script and styles generated during the initial rendering phase (from the requestContext) and initialises the iframe's script and style cache. It removes itself from its decorated component after the first rendering.!

!PRAdminIFrameDecorator methodsFor: 'rendering' stamp: 'NickAger 2/13/2012 15:41'!
renderContentOn: html
	| initialHeadScripts initialHeadStyles |
	
	super renderContentOn: html.
	
	"populate with initial head scripts and styles"
	initialHeadScripts := self requestContext headScripts asJavascript.
	html script:  'window.parent.alreadyInstalledIFrameScripts = ', initialHeadScripts, ';'.
	
	initialHeadStyles := self requestContext headStyles asJavascript.
	html script:  'window.parent.alreadyInstalledIFrameStyles = ', initialHeadStyles, ';'.
	
	self remove. "remove this decoration - its only needed the first time"! !

!WASession methodsFor: '*pier-admin' stamp: 'NickAger 11/9/2011 21:31'!
pierAdminAnnouncer
	^ self properties at: #pierAdminAnnouncer ifAbsentPut: [ Announcer new ]! !

PRRemoveCommand subclass: #PRAdminRemoveCommand
	instanceVariableNames: 'idOfTreeNodeToRemove pierAdminAnnouncer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminRemoveCommand commentStamp: 'NickAger 2/13/2012 15:52' prior: 0!
I specialise ==PRRemoveCommand== to add a script to the ajax update which will remove the selected entry node from the navigator tree in the admin UI. !

!PRAdminRemoveCommand class methodsFor: 'instance creation' stamp: 'NickAger 11/18/2011 09:54'!
idOfTreeNodeToRemove: idOfTreeNodeToRemove pierAdminAnnouncer: pierAdminAnnouncer
	^ self new
		idOfTreeNodeToRemove: idOfTreeNodeToRemove;
		pierAdminAnnouncer: pierAdminAnnouncer;
		yourself! !

!PRAdminRemoveCommand methodsFor: 'events' stamp: 'NickAger 11/18/2011 19:09'!
doValidate
	super doValidate.
	
	"user has confirmed remove so add to ajax update a script to delete the removed node 
	within the client-side tree"
	self pierAdminAnnouncer on: PRAdminAjaxUpdate do: [ :ajaxUpdate |
		| s |
		s := ajaxUpdate script.
		s << (s jQuery: #navigator) tree remove: (s jQuery id: (self idOfTreeNodeToRemove)).
		self pierAdminAnnouncer unsubscribe: self ]! !

!PRAdminRemoveCommand methodsFor: 'accessing' stamp: 'NickAger 11/18/2011 09:55'!
idOfTreeNodeToRemove
	^ idOfTreeNodeToRemove! !

!PRAdminRemoveCommand methodsFor: 'accessing' stamp: 'NickAger 11/18/2011 09:55'!
idOfTreeNodeToRemove: anObject
	idOfTreeNodeToRemove := anObject! !

!PRAdminRemoveCommand methodsFor: 'accessing' stamp: 'NickAger 11/18/2011 09:53'!
pierAdminAnnouncer
	^ pierAdminAnnouncer! !

!PRAdminRemoveCommand methodsFor: 'accessing' stamp: 'NickAger 11/18/2011 09:53'!
pierAdminAnnouncer: anObject
	pierAdminAnnouncer := anObject! !

WASystemConfiguration subclass: #PRAdminConfigurator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-Core'!

!PRAdminConfigurator commentStamp: 'NickAger 2/13/2012 16:27' prior: 0!
I provide a ==/config== configurator UI for Pier Admin. !

!PRAdminConfigurator methodsFor: 'private' stamp: 'NickAger 2/13/2012 16:48'!
commandClasses
	^ PRCommand withAllConcreteClasses collect: [ :each | each name ]! !

!PRAdminConfigurator methodsFor: 'defaults' stamp: 'NickAger 2/13/2012 16:02'!
defaultViews
	^ #(PRChangesView PRDiffView PUBrowseComponent PRHaloView PRSearchView)! !

!PRAdminConfigurator methodsFor: 'description' stamp: 'NickAger 3/7/2012 08:44'!
describeAdminKernelPathPairOn: configuration
	(configuration list: #pierAdminKernelPathPair)
		comment: 'Which kernel to administer';
		options: [ PRAdminKernelPathPair kernelPathPairs ];
		default: nil! !

!PRAdminConfigurator methodsFor: 'description' stamp: 'NickAger 3/7/2012 08:44'!
describeGlobalCommandsOn: configuration
	(configuration collection: #pierAdminCommands)
		group: #pierAdmin;
		label: 'Global commands';
		comment: 'Pier commands to display in the administration interface';
		options: [ self commandClasses ];
		default: self filteredCommandClasses.! !

!PRAdminConfigurator methodsFor: 'description' stamp: 'NickAger 3/7/2012 08:44'!
describeOn: configuration
	self describeViewsOn: configuration.
	self describeGlobalCommandsOn: configuration.
	self describeAdminKernelPathPairOn: configuration
! !

!PRAdminConfigurator methodsFor: 'description' stamp: 'NickAger 3/7/2012 08:44'!
describeViewsOn: configuration
	(configuration collection: #pierAdminViews)
		group: #pierAdmin;
		label: 'Tabbed Views';
		comment: 'Pier views to display in the administration interface - preview is always available';
		options: [ PRViewComponent withAllConcreteClasses ];
		default: self defaultViews.
! !

!PRAdminConfigurator methodsFor: 'private' stamp: 'NickAger 2/14/2012 10:46'!
excludedCommandClasses
	^ #(PRWikiTextEditingCommand PRAddCommand PREditCommand PRCopyCommand PROrderCommand PRRemoveCommand PRAdminRemoveCommand PRMoveCommand PRViewCommand PULogin PULogout PRSettingsCommand PUChangeOwner PUChangeGroup PUChangeOther)! !

!PRAdminConfigurator methodsFor: 'private' stamp: 'NickAger 2/13/2012 16:51'!
filteredCommandClasses
	^ (self commandClasses) copyWithoutAll: (self excludedCommandClasses)! !

Object subclass: #PRAdminKernelPathPair
	instanceVariableNames: 'kernel path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-Setup-Core'!

!PRAdminKernelPathPair class methodsFor: 'instance creation' stamp: 'NickAger 3/5/2012 15:32'!
kernel: kernel path: path 
	^ self new
		kernel: kernel;
		path: path;
		yourself! !

!PRAdminKernelPathPair class methodsFor: 'collection creation' stamp: 'NickAger 3/5/2012 15:00'!
kernelPathPairs
	| kernelPathPairs |
	kernelPathPairs := OrderedCollection new.
	
	PRAdminSetup recursiveDispatcherHandersDo: [ :handler :handlerPath |
		| kernel |
		
		[ (handler isApplication and: [ (kernel := handler preferenceAt: #kernel) notNil ]) ifTrue: [
			kernelPathPairs add: (self kernel: kernel path: handlerPath) ]
		 ] 
		"no
		      WARequestHandler>>#preferenceAt:ifAbsent: 
	 	so have to handle the exception"
		on: WAAttributeNotFound do: [ :err | "do nothing" ] ].
	
	^ kernelPathPairs
! !

!PRAdminKernelPathPair methodsFor: 'comparing' stamp: 'NickAger 3/5/2012 16:44'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ path = anObject path and: [ kernel = anObject kernel ]! !

!PRAdminKernelPathPair methodsFor: 'comparing' stamp: 'NickAger 3/5/2012 16:44'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ path hash bitXor: kernel hash! !

!PRAdminKernelPathPair methodsFor: 'accessing' stamp: 'NickAger 3/1/2012 17:13'!
kernel
	^ kernel! !

!PRAdminKernelPathPair methodsFor: 'accessing' stamp: 'NickAger 3/1/2012 17:13'!
kernel: anObject
	kernel := anObject! !

!PRAdminKernelPathPair methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 15:31'!
path
	^ path! !

!PRAdminKernelPathPair methodsFor: 'accessing' stamp: 'NickAger 3/5/2012 15:31'!
path: anObject
	path := anObject! !

!PRAdminKernelPathPair methodsFor: 'printing' stamp: 'NickAger 3/5/2012 14:55'!
printOn: aStream
	aStream 
		nextPutAll: 'kernel (';
		nextPutAll: self kernel name;
		nextPutAll: '), path (';
		nextPutAll: self path;
		nextPut: $)! !

WAHtmlRoot subclass: #PRAdminHtmlRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin-UI'!

!PRAdminHtmlRoot commentStamp: 'NickAger 11/24/2011 17:15' prior: 0!
PRAdminHtmlRoot provides accessors for retrieving head script and styles generated during a render phase.!

!PRAdminHtmlRoot methodsFor: 'acessing' stamp: 'NickAger 11/9/2011 15:55'!
closingConditionalCommentClasses
	^ #(WAClosingConditionalComment WAClosingRevealedConditionalComment)! !

!PRAdminHtmlRoot methodsFor: 'acessing' stamp: 'NickAger 11/9/2011 15:55'!
openingConditionalCommentClasses
	^ #(WAOpeningConditionalComment WAOpeningRevealedConditionalComment)! !

!PRAdminHtmlRoot methodsFor: 'helpers' stamp: 'NickAger 3/7/2012 08:49'!
renderStyleFor: elements
	| document |	
	document := WAHtmlDocument new.
		
	elements do: [ :each |
		each encodeOn: document ].
	
	^ document stream contents! !

!PRAdminHtmlRoot methodsFor: 'acessing' stamp: 'NickAger 3/7/2012 08:58'!
scripts
	| headElementScripts |
	headElementScripts := (self headElements
		select: [ :each | (each class canUnderstand: #tag) and: [ each tag = 'script' ] ])
		collect: [ :each | each scriptContents ].
	^ headElementScripts , (scripts ifNil: [ #() ]) asArray! !

!PRAdminHtmlRoot methodsFor: 'acessing' stamp: 'NickAger 2/13/2012 20:30'!
styles
	| styleElements groupedElements withinConditionalElement |
	styleElements := self headElements 
		select: [ :each | 
			(((each class canUnderstand: #typeOrNil) and: [ each typeOrNil = WAMimeType textCss ])
			or: [ self openingConditionalCommentClasses includes: each class name ])
			or: [ self closingConditionalCommentClasses includes: each class name ] ].
	
	"group conditional comments with styles so that we add the style within any conditional comments"
	groupedElements := 	OrderedCollection new.
	withinConditionalElement := false.
	styleElements do: [ :each |
		(self openingConditionalCommentClasses includes: each class name) 
			ifTrue: [
				withinConditionalElement := true.
				groupedElements add: (OrderedCollection with: each) ]
			ifFalse: [
				withinConditionalElement 
					ifTrue: [
						groupedElements last add: each ]
					ifFalse: [
						groupedElements add: (OrderedCollection with: each) ] ].
		(self closingConditionalCommentClasses includes: each class name) ifTrue: [
				withinConditionalElement := false ] ].

	^ (groupedElements collect: [ :each |
		self renderStyleFor: each ]), ((styles ifNil: [ #() ]) asArray)! !
PRAdminSetup initialize!
